/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _g3states_h_
#define _g3states_h_

/* DO NOT EDIT THIS FILE, IT WAS AUTOMATICALLY CREATED BY mkg3state */
#define	ACT_INCOMP	0	/* incompletely decoded code */
#define	ACT_INVALID	1	/* invalide code */
#define	ACT_WRUNT	2	/* terminating white run code */
#define	ACT_WRUN	65	/* non-terminating white run code */
#define	ACT_BRUNT	106	/* terminating black run code */
#define	ACT_BRUN	169	/* non-terminating black run code */
#define	ACT_EOL	210	/* end-of-line code */

/* modes that the decoder can be in */
enum {
	MODE_NULL= 0,
	MODE_PASS,
	MODE_HORIZ,
	MODE_VERT_VL3,
	MODE_VERT_VL2,
	MODE_VERT_VL1,
	MODE_VERT_V0,
	MODE_VERT_VR1,
	MODE_VERT_VR2,
	MODE_VERT_VR3,
	MODE_UNCOMP	,
	MODE_ERROR,
	MODE_ERROR_1,
	MODE_EOL,
	MODE_EOD,
	MODE_RUN,
	MODE_H1,
	MODE_H2
};

#define	UNCOMP_INCOMP	0
/* runs of [0]*1 */
#define	UNCOMP_RUN0	1
#define	UNCOMP_RUN1	2
#define	UNCOMP_RUN2	3
#define	UNCOMP_RUN3	4
#define	UNCOMP_RUN4	5
#define	UNCOMP_RUN5	6
#define	UNCOMP_RUN6	7
/* runs of [0]* w/ terminating color */
#define	UNCOMP_TRUN0	8
#define	UNCOMP_TRUN1	9
#define	UNCOMP_TRUN2	10
#define	UNCOMP_TRUN3	11
#define	UNCOMP_TRUN4	12
/* special code for unexpected EOF */
#define	UNCOMP_EOF	13
/* invalid code encountered */
#define	UNCOMP_INVALID	14
/* codes >= terminate uncompress mode */
#define	UNCOMP_EXIT	UNCOMP_TRUN0

extern	unsigned char RlMode2D[][256];
extern	unsigned char RlNextState2D[][256];
extern	unsigned char RlUncompAction[][256];
extern	unsigned char RlUncompNextState[][256];
extern	unsigned char RlAction1D[][256];
extern	unsigned char RlNextState1D[][256];

#endif
