/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#include "rafport.h"
#include "entity.h"
#include "rlimage.h"

#ifdef MAKETABLE
#define MAKETABLE

main()
{
	int4 i,j,len;
	long val;
	
	val = 32;
	for (i=0;i<32;i++) {
		printf("%d, ",val);
		val += 33-i;
		if (!(i % 8)) printf("\n");
	}
	printf("\n");
	for (i=0;i<32;i++) {
		for (j=0;j<=(32-i);j++) {
			if (!(j%4)) printf("\n");
			len = j;
			val = 0;
			while (len--)
				val |= 1 << len;
			val <<= 32 - i - j;
			val = i_SwapL(val);
			printf("0x%lx, ",val);
		}
		printf("\n");
	}
}
#else

static long *r2rtab = 0;

/* size is 591 * 4 */
static long r2rtabswap[] = {
	32, 
	65, 97, 128, 158, 187, 215, 242, 268, 
	293, 317, 340, 362, 383, 403, 422, 440, 
	457, 473, 488, 502, 515, 527, 538, 548, 
	557, 565, 572, 578, 583, 587, 590, 
	
	0x0, 0x80, 0xc0, 0xe0, 
	0xf0, 0xf8, 0xfc, 0xfe, 
	0xff, 0x80ff, 0xc0ff, 0xe0ff, 
	0xf0ff, 0xf8ff, 0xfcff, 0xfeff, 
	0xffff, 0x80ffff, 0xc0ffff, 0xe0ffff, 
	0xf0ffff, 0xf8ffff, 0xfcffff, 0xfeffff, 
	0xffffff, 0x80ffffff, 0xc0ffffff, 0xe0ffffff, 
	0xf0ffffff, 0xf8ffffff, 0xfcffffff, 0xfeffffff, 
	0xffffffff, 
	
	0x0, 0x40, 0x60, 0x70, 
	0x78, 0x7c, 0x7e, 0x7f, 
	0x807f, 0xc07f, 0xe07f, 0xf07f, 
	0xf87f, 0xfc7f, 0xfe7f, 0xff7f, 
	0x80ff7f, 0xc0ff7f, 0xe0ff7f, 0xf0ff7f, 
	0xf8ff7f, 0xfcff7f, 0xfeff7f, 0xffff7f, 
	0x80ffff7f, 0xc0ffff7f, 0xe0ffff7f, 0xf0ffff7f, 
	0xf8ffff7f, 0xfcffff7f, 0xfeffff7f, 0xffffff7f, 
	
	0x0, 0x20, 0x30, 0x38, 
	0x3c, 0x3e, 0x3f, 0x803f, 
	0xc03f, 0xe03f, 0xf03f, 0xf83f, 
	0xfc3f, 0xfe3f, 0xff3f, 0x80ff3f, 
	0xc0ff3f, 0xe0ff3f, 0xf0ff3f, 0xf8ff3f, 
	0xfcff3f, 0xfeff3f, 0xffff3f, 0x80ffff3f, 
	0xc0ffff3f, 0xe0ffff3f, 0xf0ffff3f, 0xf8ffff3f, 
	0xfcffff3f, 0xfeffff3f, 0xffffff3f, 
	
	0x0, 0x10, 0x18, 0x1c, 
	0x1e, 0x1f, 0x801f, 0xc01f, 
	0xe01f, 0xf01f, 0xf81f, 0xfc1f, 
	0xfe1f, 0xff1f, 0x80ff1f, 0xc0ff1f, 
	0xe0ff1f, 0xf0ff1f, 0xf8ff1f, 0xfcff1f, 
	0xfeff1f, 0xffff1f, 0x80ffff1f, 0xc0ffff1f, 
	0xe0ffff1f, 0xf0ffff1f, 0xf8ffff1f, 0xfcffff1f, 
	0xfeffff1f, 0xffffff1f, 
	
	0x0, 0x8, 0xc, 0xe, 
	0xf, 0x800f, 0xc00f, 0xe00f, 
	0xf00f, 0xf80f, 0xfc0f, 0xfe0f, 
	0xff0f, 0x80ff0f, 0xc0ff0f, 0xe0ff0f, 
	0xf0ff0f, 0xf8ff0f, 0xfcff0f, 0xfeff0f, 
	0xffff0f, 0x80ffff0f, 0xc0ffff0f, 0xe0ffff0f, 
	0xf0ffff0f, 0xf8ffff0f, 0xfcffff0f, 0xfeffff0f, 
	0xffffff0f, 
	
	0x0, 0x4, 0x6, 0x7, 
	0x8007, 0xc007, 0xe007, 0xf007, 
	0xf807, 0xfc07, 0xfe07, 0xff07, 
	0x80ff07, 0xc0ff07, 0xe0ff07, 0xf0ff07, 
	0xf8ff07, 0xfcff07, 0xfeff07, 0xffff07, 
	0x80ffff07, 0xc0ffff07, 0xe0ffff07, 0xf0ffff07, 
	0xf8ffff07, 0xfcffff07, 0xfeffff07, 0xffffff07, 
	
	0x0, 0x2, 0x3, 0x8003, 
	0xc003, 0xe003, 0xf003, 0xf803, 
	0xfc03, 0xfe03, 0xff03, 0x80ff03, 
	0xc0ff03, 0xe0ff03, 0xf0ff03, 0xf8ff03, 
	0xfcff03, 0xfeff03, 0xffff03, 0x80ffff03, 
	0xc0ffff03, 0xe0ffff03, 0xf0ffff03, 0xf8ffff03, 
	0xfcffff03, 0xfeffff03, 0xffffff03, 
	
	0x0, 0x1, 0x8001, 0xc001, 
	0xe001, 0xf001, 0xf801, 0xfc01, 
	0xfe01, 0xff01, 0x80ff01, 0xc0ff01, 
	0xe0ff01, 0xf0ff01, 0xf8ff01, 0xfcff01, 
	0xfeff01, 0xffff01, 0x80ffff01, 0xc0ffff01, 
	0xe0ffff01, 0xf0ffff01, 0xf8ffff01, 0xfcffff01, 
	0xfeffff01, 0xffffff01, 
	
	0x0, 0x8000, 0xc000, 0xe000, 
	0xf000, 0xf800, 0xfc00, 0xfe00, 
	0xff00, 0x80ff00, 0xc0ff00, 0xe0ff00, 
	0xf0ff00, 0xf8ff00, 0xfcff00, 0xfeff00, 
	0xffff00, 0x80ffff00, 0xc0ffff00, 0xe0ffff00, 
	0xf0ffff00, 0xf8ffff00, 0xfcffff00, 0xfeffff00, 
	0xffffff00, 
	
	0x0, 0x4000, 0x6000, 0x7000, 
	0x7800, 0x7c00, 0x7e00, 0x7f00, 
	0x807f00, 0xc07f00, 0xe07f00, 0xf07f00, 
	0xf87f00, 0xfc7f00, 0xfe7f00, 0xff7f00, 
	0x80ff7f00, 0xc0ff7f00, 0xe0ff7f00, 0xf0ff7f00, 
	0xf8ff7f00, 0xfcff7f00, 0xfeff7f00, 0xffff7f00, 
	
	0x0, 0x2000, 0x3000, 0x3800, 
	0x3c00, 0x3e00, 0x3f00, 0x803f00, 
	0xc03f00, 0xe03f00, 0xf03f00, 0xf83f00, 
	0xfc3f00, 0xfe3f00, 0xff3f00, 0x80ff3f00, 
	0xc0ff3f00, 0xe0ff3f00, 0xf0ff3f00, 0xf8ff3f00, 
	0xfcff3f00, 0xfeff3f00, 0xffff3f00, 
	
	0x0, 0x1000, 0x1800, 0x1c00, 
	0x1e00, 0x1f00, 0x801f00, 0xc01f00, 
	0xe01f00, 0xf01f00, 0xf81f00, 0xfc1f00, 
	0xfe1f00, 0xff1f00, 0x80ff1f00, 0xc0ff1f00, 
	0xe0ff1f00, 0xf0ff1f00, 0xf8ff1f00, 0xfcff1f00, 
	0xfeff1f00, 0xffff1f00, 
	
	0x0, 0x800, 0xc00, 0xe00, 
	0xf00, 0x800f00, 0xc00f00, 0xe00f00, 
	0xf00f00, 0xf80f00, 0xfc0f00, 0xfe0f00, 
	0xff0f00, 0x80ff0f00, 0xc0ff0f00, 0xe0ff0f00, 
	0xf0ff0f00, 0xf8ff0f00, 0xfcff0f00, 0xfeff0f00, 
	0xffff0f00, 
	
	0x0, 0x400, 0x600, 0x700, 
	0x800700, 0xc00700, 0xe00700, 0xf00700, 
	0xf80700, 0xfc0700, 0xfe0700, 0xff0700, 
	0x80ff0700, 0xc0ff0700, 0xe0ff0700, 0xf0ff0700, 
	0xf8ff0700, 0xfcff0700, 0xfeff0700, 0xffff0700, 
	
	0x0, 0x200, 0x300, 0x800300, 
	0xc00300, 0xe00300, 0xf00300, 0xf80300, 
	0xfc0300, 0xfe0300, 0xff0300, 0x80ff0300, 
	0xc0ff0300, 0xe0ff0300, 0xf0ff0300, 0xf8ff0300, 
	0xfcff0300, 0xfeff0300, 0xffff0300, 
	
	0x0, 0x100, 0x800100, 0xc00100, 
	0xe00100, 0xf00100, 0xf80100, 0xfc0100, 
	0xfe0100, 0xff0100, 0x80ff0100, 0xc0ff0100, 
	0xe0ff0100, 0xf0ff0100, 0xf8ff0100, 0xfcff0100, 
	0xfeff0100, 0xffff0100, 
	
	0x0, 0x800000, 0xc00000, 0xe00000, 
	0xf00000, 0xf80000, 0xfc0000, 0xfe0000, 
	0xff0000, 0x80ff0000, 0xc0ff0000, 0xe0ff0000, 
	0xf0ff0000, 0xf8ff0000, 0xfcff0000, 0xfeff0000, 
	0xffff0000, 
	
	0x0, 0x400000, 0x600000, 0x700000, 
	0x780000, 0x7c0000, 0x7e0000, 0x7f0000, 
	0x807f0000, 0xc07f0000, 0xe07f0000, 0xf07f0000, 
	0xf87f0000, 0xfc7f0000, 0xfe7f0000, 0xff7f0000, 
	
	0x0, 0x200000, 0x300000, 0x380000, 
	0x3c0000, 0x3e0000, 0x3f0000, 0x803f0000, 
	0xc03f0000, 0xe03f0000, 0xf03f0000, 0xf83f0000, 
	0xfc3f0000, 0xfe3f0000, 0xff3f0000, 
	
	0x0, 0x100000, 0x180000, 0x1c0000, 
	0x1e0000, 0x1f0000, 0x801f0000, 0xc01f0000, 
	0xe01f0000, 0xf01f0000, 0xf81f0000, 0xfc1f0000, 
	0xfe1f0000, 0xff1f0000, 
	
	0x0, 0x80000, 0xc0000, 0xe0000, 
	0xf0000, 0x800f0000, 0xc00f0000, 0xe00f0000, 
	0xf00f0000, 0xf80f0000, 0xfc0f0000, 0xfe0f0000, 
	0xff0f0000, 
	
	0x0, 0x40000, 0x60000, 0x70000, 
	0x80070000, 0xc0070000, 0xe0070000, 0xf0070000, 
	0xf8070000, 0xfc070000, 0xfe070000, 0xff070000, 
	
	0x0, 0x20000, 0x30000, 0x80030000, 
	0xc0030000, 0xe0030000, 0xf0030000, 0xf8030000, 
	0xfc030000, 0xfe030000, 0xff030000, 
	
	0x0, 0x10000, 0x80010000, 0xc0010000, 
	0xe0010000, 0xf0010000, 0xf8010000, 0xfc010000, 
	0xfe010000, 0xff010000, 
	
	0x0, 0x80000000, 0xc0000000, 0xe0000000, 
	0xf0000000, 0xf8000000, 0xfc000000, 0xfe000000, 
	0xff000000, 
	
	0x0, 0x40000000, 0x60000000, 0x70000000, 
	0x78000000, 0x7c000000, 0x7e000000, 0x7f000000, 
	
	0x0, 0x20000000, 0x30000000, 0x38000000, 
	0x3c000000, 0x3e000000, 0x3f000000, 
	
	0x0, 0x10000000, 0x18000000, 0x1c000000, 
	0x1e000000, 0x1f000000, 
	
	0x0, 0x8000000, 0xc000000, 0xe000000, 
	0xf000000, 
	
	0x0, 0x4000000, 0x6000000, 0x7000000, 
	
	0x0, 0x2000000, 0x3000000, 
	
	0x0, 0x1000000
};

static long r2rtabnorm[] = { 
	32, 
	65, 97, 128, 158, 187, 215, 242, 268, 
	293, 317, 340, 362, 383, 403, 422, 440, 
	457, 473, 488, 502, 515, 527, 538, 548, 
	557, 565, 572, 578, 583, 587, 590, 
	
	0x0, 0x80000000, 0xc0000000, 0xe0000000, 
	0xf0000000, 0xf8000000, 0xfc000000, 0xfe000000, 
	0xff000000, 0xff800000, 0xffc00000, 0xffe00000, 
	0xfff00000, 0xfff80000, 0xfffc0000, 0xfffe0000, 
	0xffff0000, 0xffff8000, 0xffffc000, 0xffffe000, 
	0xfffff000, 0xfffff800, 0xfffffc00, 0xfffffe00, 
	0xffffff00, 0xffffff80, 0xffffffc0, 0xffffffe0, 
	0xfffffff0, 0xfffffff8, 0xfffffffc, 0xfffffffe, 
	0xffffffff, 
	
	0x0, 0x40000000, 0x60000000, 0x70000000, 
	0x78000000, 0x7c000000, 0x7e000000, 0x7f000000, 
	0x7f800000, 0x7fc00000, 0x7fe00000, 0x7ff00000, 
	0x7ff80000, 0x7ffc0000, 0x7ffe0000, 0x7fff0000, 
	0x7fff8000, 0x7fffc000, 0x7fffe000, 0x7ffff000, 
	0x7ffff800, 0x7ffffc00, 0x7ffffe00, 0x7fffff00, 
	0x7fffff80, 0x7fffffc0, 0x7fffffe0, 0x7ffffff0, 
	0x7ffffff8, 0x7ffffffc, 0x7ffffffe, 0x7fffffff, 
	
	0x0, 0x20000000, 0x30000000, 0x38000000, 
	0x3c000000, 0x3e000000, 0x3f000000, 0x3f800000, 
	0x3fc00000, 0x3fe00000, 0x3ff00000, 0x3ff80000, 
	0x3ffc0000, 0x3ffe0000, 0x3fff0000, 0x3fff8000, 
	0x3fffc000, 0x3fffe000, 0x3ffff000, 0x3ffff800, 
	0x3ffffc00, 0x3ffffe00, 0x3fffff00, 0x3fffff80, 
	0x3fffffc0, 0x3fffffe0, 0x3ffffff0, 0x3ffffff8, 
	0x3ffffffc, 0x3ffffffe, 0x3fffffff, 
	
	0x0, 0x10000000, 0x18000000, 0x1c000000, 
	0x1e000000, 0x1f000000, 0x1f800000, 0x1fc00000, 
	0x1fe00000, 0x1ff00000, 0x1ff80000, 0x1ffc0000, 
	0x1ffe0000, 0x1fff0000, 0x1fff8000, 0x1fffc000, 
	0x1fffe000, 0x1ffff000, 0x1ffff800, 0x1ffffc00, 
	0x1ffffe00, 0x1fffff00, 0x1fffff80, 0x1fffffc0, 
	0x1fffffe0, 0x1ffffff0, 0x1ffffff8, 0x1ffffffc, 
	0x1ffffffe, 0x1fffffff, 
	
	0x0, 0x8000000, 0xc000000, 0xe000000, 
	0xf000000, 0xf800000, 0xfc00000, 0xfe00000, 
	0xff00000, 0xff80000, 0xffc0000, 0xffe0000, 
	0xfff0000, 0xfff8000, 0xfffc000, 0xfffe000, 
	0xffff000, 0xffff800, 0xffffc00, 0xffffe00, 
	0xfffff00, 0xfffff80, 0xfffffc0, 0xfffffe0, 
	0xffffff0, 0xffffff8, 0xffffffc, 0xffffffe, 
	0xfffffff, 
	
	0x0, 0x4000000, 0x6000000, 0x7000000, 
	0x7800000, 0x7c00000, 0x7e00000, 0x7f00000, 
	0x7f80000, 0x7fc0000, 0x7fe0000, 0x7ff0000, 
	0x7ff8000, 0x7ffc000, 0x7ffe000, 0x7fff000, 
	0x7fff800, 0x7fffc00, 0x7fffe00, 0x7ffff00, 
	0x7ffff80, 0x7ffffc0, 0x7ffffe0, 0x7fffff0, 
	0x7fffff8, 0x7fffffc, 0x7fffffe, 0x7ffffff, 
	
	0x0, 0x2000000, 0x3000000, 0x3800000, 
	0x3c00000, 0x3e00000, 0x3f00000, 0x3f80000, 
	0x3fc0000, 0x3fe0000, 0x3ff0000, 0x3ff8000, 
	0x3ffc000, 0x3ffe000, 0x3fff000, 0x3fff800, 
	0x3fffc00, 0x3fffe00, 0x3ffff00, 0x3ffff80, 
	0x3ffffc0, 0x3ffffe0, 0x3fffff0, 0x3fffff8, 
	0x3fffffc, 0x3fffffe, 0x3ffffff, 
	
	0x0, 0x1000000, 0x1800000, 0x1c00000, 
	0x1e00000, 0x1f00000, 0x1f80000, 0x1fc0000, 
	0x1fe0000, 0x1ff0000, 0x1ff8000, 0x1ffc000, 
	0x1ffe000, 0x1fff000, 0x1fff800, 0x1fffc00, 
	0x1fffe00, 0x1ffff00, 0x1ffff80, 0x1ffffc0, 
	0x1ffffe0, 0x1fffff0, 0x1fffff8, 0x1fffffc, 
	0x1fffffe, 0x1ffffff, 
	
	0x0, 0x800000, 0xc00000, 0xe00000, 
	0xf00000, 0xf80000, 0xfc0000, 0xfe0000, 
	0xff0000, 0xff8000, 0xffc000, 0xffe000, 
	0xfff000, 0xfff800, 0xfffc00, 0xfffe00, 
	0xffff00, 0xffff80, 0xffffc0, 0xffffe0, 
	0xfffff0, 0xfffff8, 0xfffffc, 0xfffffe, 
	0xffffff, 
	
	0x0, 0x400000, 0x600000, 0x700000, 
	0x780000, 0x7c0000, 0x7e0000, 0x7f0000, 
	0x7f8000, 0x7fc000, 0x7fe000, 0x7ff000, 
	0x7ff800, 0x7ffc00, 0x7ffe00, 0x7fff00, 
	0x7fff80, 0x7fffc0, 0x7fffe0, 0x7ffff0, 
	0x7ffff8, 0x7ffffc, 0x7ffffe, 0x7fffff, 
	
	0x0, 0x200000, 0x300000, 0x380000, 
	0x3c0000, 0x3e0000, 0x3f0000, 0x3f8000, 
	0x3fc000, 0x3fe000, 0x3ff000, 0x3ff800, 
	0x3ffc00, 0x3ffe00, 0x3fff00, 0x3fff80, 
	0x3fffc0, 0x3fffe0, 0x3ffff0, 0x3ffff8, 
	0x3ffffc, 0x3ffffe, 0x3fffff, 
	
	0x0, 0x100000, 0x180000, 0x1c0000, 
	0x1e0000, 0x1f0000, 0x1f8000, 0x1fc000, 
	0x1fe000, 0x1ff000, 0x1ff800, 0x1ffc00, 
	0x1ffe00, 0x1fff00, 0x1fff80, 0x1fffc0, 
	0x1fffe0, 0x1ffff0, 0x1ffff8, 0x1ffffc, 
	0x1ffffe, 0x1fffff, 
	
	0x0, 0x80000, 0xc0000, 0xe0000, 
	0xf0000, 0xf8000, 0xfc000, 0xfe000, 
	0xff000, 0xff800, 0xffc00, 0xffe00, 
	0xfff00, 0xfff80, 0xfffc0, 0xfffe0, 
	0xffff0, 0xffff8, 0xffffc, 0xffffe, 
	0xfffff, 
	
	0x0, 0x40000, 0x60000, 0x70000, 
	0x78000, 0x7c000, 0x7e000, 0x7f000, 
	0x7f800, 0x7fc00, 0x7fe00, 0x7ff00, 
	0x7ff80, 0x7ffc0, 0x7ffe0, 0x7fff0, 
	0x7fff8, 0x7fffc, 0x7fffe, 0x7ffff, 
	
	0x0, 0x20000, 0x30000, 0x38000, 
	0x3c000, 0x3e000, 0x3f000, 0x3f800, 
	0x3fc00, 0x3fe00, 0x3ff00, 0x3ff80, 
	0x3ffc0, 0x3ffe0, 0x3fff0, 0x3fff8, 
	0x3fffc, 0x3fffe, 0x3ffff, 
	
	0x0, 0x10000, 0x18000, 0x1c000, 
	0x1e000, 0x1f000, 0x1f800, 0x1fc00, 
	0x1fe00, 0x1ff00, 0x1ff80, 0x1ffc0, 
	0x1ffe0, 0x1fff0, 0x1fff8, 0x1fffc, 
	0x1fffe, 0x1ffff, 
	
	0x0, 0x8000, 0xc000, 0xe000, 
	0xf000, 0xf800, 0xfc00, 0xfe00, 
	0xff00, 0xff80, 0xffc0, 0xffe0, 
	0xfff0, 0xfff8, 0xfffc, 0xfffe, 
	0xffff, 
	
	0x0, 0x4000, 0x6000, 0x7000, 
	0x7800, 0x7c00, 0x7e00, 0x7f00, 
	0x7f80, 0x7fc0, 0x7fe0, 0x7ff0, 
	0x7ff8, 0x7ffc, 0x7ffe, 0x7fff, 
	
	0x0, 0x2000, 0x3000, 0x3800, 
	0x3c00, 0x3e00, 0x3f00, 0x3f80, 
	0x3fc0, 0x3fe0, 0x3ff0, 0x3ff8, 
	0x3ffc, 0x3ffe, 0x3fff, 
	
	0x0, 0x1000, 0x1800, 0x1c00, 
	0x1e00, 0x1f00, 0x1f80, 0x1fc0, 
	0x1fe0, 0x1ff0, 0x1ff8, 0x1ffc, 
	0x1ffe, 0x1fff, 
	
	0x0, 0x800, 0xc00, 0xe00, 
	0xf00, 0xf80, 0xfc0, 0xfe0, 
	0xff0, 0xff8, 0xffc, 0xffe, 
	0xfff, 
	
	0x0, 0x400, 0x600, 0x700, 
	0x780, 0x7c0, 0x7e0, 0x7f0, 
	0x7f8, 0x7fc, 0x7fe, 0x7ff, 
	
	0x0, 0x200, 0x300, 0x380, 
	0x3c0, 0x3e0, 0x3f0, 0x3f8, 
	0x3fc, 0x3fe, 0x3ff, 
	
	0x0, 0x100, 0x180, 0x1c0, 
	0x1e0, 0x1f0, 0x1f8, 0x1fc, 
	0x1fe, 0x1ff, 
	
	0x0, 0x80, 0xc0, 0xe0, 
	0xf0, 0xf8, 0xfc, 0xfe, 
	0xff, 
	
	0x0, 0x40, 0x60, 0x70, 
	0x78, 0x7c, 0x7e, 0x7f, 
	
	0x0, 0x20, 0x30, 0x38, 
	0x3c, 0x3e, 0x3f, 
	
	0x0, 0x10, 0x18, 0x1c, 
	0x1e, 0x1f, 
	
	0x0, 0x8, 0xc, 0xe, 
	0xf, 
	
	0x0, 0x4, 0x6, 0x7, 
	
	0x0, 0x2, 0x3, 
	
	0x0, 0x1
};


void
i_InitRasNRun(void)
{
	short s = 1;
	if (*(char*)&s == 1)
		r2rtab = r2rtabswap;
	else r2rtab = r2rtabnorm;
}

/*	this requires an extra long at the end of the output bit stream */
/* it returns the number of bytes in the output stream but it wrote to */
/* one more long than it is returning */
void Run2Ras(short *run,char *outbuf)
{
	int2 o,st,tmp,len;
	unsigned long *olp,*nlp,*op = (unsigned long*)outbuf;
	
	o = 0;
	olp = op;
	*olp = 0;
#ifdef PIXCOMPAT
	run++;
#endif
	for (;;) {
		st = *run++;
		if (st < 0) break;
		len = *run++;
#ifdef PIXCOMPAT
		if (len < 0) break;
#endif
		len -= st;
		nlp = op + (st >> 5);
		if (nlp > olp) {
			olp++;
			while ((nlp - olp) > 4) {
				*olp++ = 0;
				*olp++ = 0;
				*olp++ = 0;
				*olp++ = 0;
			}
			while (olp < nlp)
				*olp++ = 0;
			*olp = 0;
		}
		o = st & 0x1f;
		tmp = 32 - o;
		if (len > tmp) {
			*nlp++ |= r2rtab[r2rtab[o] + tmp];
			len -= tmp;
			while (len > 32) {
				*nlp++ = 0xffffffff;
				len -= 32;
			}
			*nlp = r2rtab[r2rtab[0] + len];
		} else
			*nlp |= r2rtab[r2rtab[o] + len];
		olp = nlp;
	}
}

/*	this requires an extra long at the end of the output bit stream */
/* it returns the number of bytes in the output stream but it wrote to */
/* one more long than it is returning */
void Run2RasMul(short *run,char *outbuf,iFixedPoint mul,int2 off)
{
	int2 o,tmp,len,st;
	unsigned long *olp,*nlp,*op = (unsigned long*)outbuf;
	
	o = 0;
	olp = op;
	*olp = 0;
#ifdef PIXCOMPAT
	run++;
#endif
	st = i_FP_TO_INT2((*run++) * mul) - off;
	if (st < 0) st = 0;
	for (;;) {
		len = i_FP_TO_INT2((*run++) * mul) - off;
#ifdef PIXCOMPAT
		if (len < 0) break;
#endif
		len -= st;
		nlp = op + (st >> 5);
		if (nlp > olp) {
			olp++;
			while ((nlp - olp) > 4) {
				*olp++ = 0;
				*olp++ = 0;
				*olp++ = 0;
				*olp++ = 0;
			}
			while (olp < nlp)
				*olp++ = 0;
			*olp = 0;
		}
		o = st & 0x1f;
		tmp = 32 - o;
		if (len > tmp) {
			*nlp++ |= r2rtab[r2rtab[o] + tmp];
			len -= tmp;
			while (len > 32) {
				*nlp++ = 0xffffffff;
				len -= 32;
			}
			*nlp = r2rtab[r2rtab[0] + len];
		} else
			*nlp |= r2rtab[r2rtab[o] + len];
		olp = nlp;
		if (*run < 0) break;
		st = i_FP_TO_INT2((*run++) * mul) - off;
	}
}


#ifdef MAKETABLE
#define MAKETABLE
maketable()
{
	int4 i;
	
	for (i=1;i<256;i++) {
		int4 t=i,c=0;
		printf("\t\t\tcase 0x%x: ",i);
		while (t & 0xff) {
			while (!(t & 0x80) && t & 0xff) {
				c++;t <<= 1;
			}
			if (c) printf("*o++=c+%d;",c);
			else printf("*o++=c;");
			while (t & 0x80 && t & 0xff) {
				c++;t <<= 1;
			}
			if (c < 8) {
				if (c) printf("*o++=c+%d;",c);
				else printf("*o++=c;");
			}
		}
		printf(i&1?"goto black;\n":"break;\n");
//		printf(i&1?"black();\n":"break;\n");
	}
	for (i=0;i<256;i++) {
		int4 t=i,c=0;
		printf("\t\t\tcase 0x%x: ",i);
		while (c < 8) {
			while (t & 0x80 && c < 8) {
				c++;t <<= 1;
			}
			if (c >= 8) break;
			if (c) printf("*o++=c+%d;",c);
			else printf("*o++=c;");
			while (!(t & 0x80) && c < 8) {
				c++;t <<= 1;
			}
			if (c < 8) {
				if (c) printf("*o++=c+%d;",c);
				else printf("*o++=c;");
			}
		}
		printf(i&1?"break;\n":"goto white;\n");
//		printf(i&1?"break;\n":"white();\n");
	}
}
#endif

int2 Ras2Run(char *inbuf,short *run,int2 width,int2 offset)
{
	unsigned char *bp,*be,*input = (unsigned char *)inbuf;
	short c;
	short *o = run;
	
	bp = input;
	be = input + width;
	width <<= 3;
#ifdef PIXCOMPAT
	*o++ = 0;
#endif
  white:
	c = (bp - input) << 3;
	c -= offset;
	while (bp < be) {
		switch (*bp++) {
		case 0: if (!((long)bp & 0x3)) goto speed; break;
		case 0x1: *o++=c+7;goto black;
		case 0x2: *o++=c+6;*o++=c+7;break;
		case 0x3: *o++=c+6;goto black;
		case 0x4: *o++=c+5;*o++=c+6;break;
		case 0x5: *o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0x6: *o++=c+5;*o++=c+7;break;
		case 0x7: *o++=c+5;goto black;
		case 0x8: *o++=c+4;*o++=c+5;break;
		case 0x9: *o++=c+4;*o++=c+5;*o++=c+7;goto black;
		case 0xa: *o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0xb: *o++=c+4;*o++=c+5;*o++=c+6;goto black;
		case 0xc: *o++=c+4;*o++=c+6;break;
		case 0xd: *o++=c+4;*o++=c+6;*o++=c+7;goto black;
		case 0xe: *o++=c+4;*o++=c+7;break;
		case 0xf: *o++=c+4;goto black;
		case 0x10: *o++=c+3;*o++=c+4;break;
		case 0x11: *o++=c+3;*o++=c+4;*o++=c+7;goto black;
		case 0x12: *o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0x13: *o++=c+3;*o++=c+4;*o++=c+6;goto black;
		case 0x14: *o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0x15: *o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0x16: *o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0x17: *o++=c+3;*o++=c+4;*o++=c+5;goto black;
		case 0x18: *o++=c+3;*o++=c+5;break;
		case 0x19: *o++=c+3;*o++=c+5;*o++=c+7;goto black;
		case 0x1a: *o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x1b: *o++=c+3;*o++=c+5;*o++=c+6;goto black;
		case 0x1c: *o++=c+3;*o++=c+6;break;
		case 0x1d: *o++=c+3;*o++=c+6;*o++=c+7;goto black;
		case 0x1e: *o++=c+3;*o++=c+7;break;
		case 0x1f: *o++=c+3;goto black;
		case 0x20: *o++=c+2;*o++=c+3;break;
		case 0x21: *o++=c+2;*o++=c+3;*o++=c+7;goto black;
		case 0x22: *o++=c+2;*o++=c+3;*o++=c+6;*o++=c+7;break;
		case 0x23: *o++=c+2;*o++=c+3;*o++=c+6;goto black;
		case 0x24: *o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;break;
		case 0x25: *o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0x26: *o++=c+2;*o++=c+3;*o++=c+5;*o++=c+7;break;
		case 0x27: *o++=c+2;*o++=c+3;*o++=c+5;goto black;
		case 0x28: *o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;break;
		case 0x29: *o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;goto black;
		case 0x2a: *o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x2b: *o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;goto black;
		case 0x2c: *o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;break;
		case 0x2d: *o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;goto black;
		case 0x2e: *o++=c+2;*o++=c+3;*o++=c+4;*o++=c+7;break;
		case 0x2f: *o++=c+2;*o++=c+3;*o++=c+4;goto black;
		case 0x30: *o++=c+2;*o++=c+4;break;
		case 0x31: *o++=c+2;*o++=c+4;*o++=c+7;goto black;
		case 0x32: *o++=c+2;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0x33: *o++=c+2;*o++=c+4;*o++=c+6;goto black;
		case 0x34: *o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0x35: *o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0x36: *o++=c+2;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0x37: *o++=c+2;*o++=c+4;*o++=c+5;goto black;
		case 0x38: *o++=c+2;*o++=c+5;break;
		case 0x39: *o++=c+2;*o++=c+5;*o++=c+7;goto black;
		case 0x3a: *o++=c+2;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x3b: *o++=c+2;*o++=c+5;*o++=c+6;goto black;
		case 0x3c: *o++=c+2;*o++=c+6;break;
		case 0x3d: *o++=c+2;*o++=c+6;*o++=c+7;goto black;
		case 0x3e: *o++=c+2;*o++=c+7;break;
		case 0x3f: *o++=c+2;goto black;
		case 0x40: *o++=c+1;*o++=c+2;break;
		case 0x41: *o++=c+1;*o++=c+2;*o++=c+7;goto black;
		case 0x42: *o++=c+1;*o++=c+2;*o++=c+6;*o++=c+7;break;
		case 0x43: *o++=c+1;*o++=c+2;*o++=c+6;goto black;
		case 0x44: *o++=c+1;*o++=c+2;*o++=c+5;*o++=c+6;break;
		case 0x45: *o++=c+1;*o++=c+2;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0x46: *o++=c+1;*o++=c+2;*o++=c+5;*o++=c+7;break;
		case 0x47: *o++=c+1;*o++=c+2;*o++=c+5;goto black;
		case 0x48: *o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;break;
		case 0x49: *o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+7;goto black;
		case 0x4a: *o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x4b: *o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;goto black;
		case 0x4c: *o++=c+1;*o++=c+2;*o++=c+4;*o++=c+6;break;
		case 0x4d: *o++=c+1;*o++=c+2;*o++=c+4;*o++=c+6;*o++=c+7;goto black;
		case 0x4e: *o++=c+1;*o++=c+2;*o++=c+4;*o++=c+7;break;
		case 0x4f: *o++=c+1;*o++=c+2;*o++=c+4;goto black;
		case 0x50: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;break;
		case 0x51: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+7;goto black;
		case 0x52: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0x53: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;goto black;
		case 0x54: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0x55: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0x56: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0x57: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;goto black;
		case 0x58: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;break;
		case 0x59: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+7;goto black;
		case 0x5a: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x5b: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;goto black;
		case 0x5c: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+6;break;
		case 0x5d: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+6;*o++=c+7;goto black;
		case 0x5e: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+7;break;
		case 0x5f: *o++=c+1;*o++=c+2;*o++=c+3;goto black;
		case 0x60: *o++=c+1;*o++=c+3;break;
		case 0x61: *o++=c+1;*o++=c+3;*o++=c+7;goto black;
		case 0x62: *o++=c+1;*o++=c+3;*o++=c+6;*o++=c+7;break;
		case 0x63: *o++=c+1;*o++=c+3;*o++=c+6;goto black;
		case 0x64: *o++=c+1;*o++=c+3;*o++=c+5;*o++=c+6;break;
		case 0x65: *o++=c+1;*o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0x66: *o++=c+1;*o++=c+3;*o++=c+5;*o++=c+7;break;
		case 0x67: *o++=c+1;*o++=c+3;*o++=c+5;goto black;
		case 0x68: *o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;break;
		case 0x69: *o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;goto black;
		case 0x6a: *o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x6b: *o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;goto black;
		case 0x6c: *o++=c+1;*o++=c+3;*o++=c+4;*o++=c+6;break;
		case 0x6d: *o++=c+1;*o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;goto black;
		case 0x6e: *o++=c+1;*o++=c+3;*o++=c+4;*o++=c+7;break;
		case 0x6f: *o++=c+1;*o++=c+3;*o++=c+4;goto black;
		case 0x70: *o++=c+1;*o++=c+4;break;
		case 0x71: *o++=c+1;*o++=c+4;*o++=c+7;goto black;
		case 0x72: *o++=c+1;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0x73: *o++=c+1;*o++=c+4;*o++=c+6;goto black;
		case 0x74: *o++=c+1;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0x75: *o++=c+1;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0x76: *o++=c+1;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0x77: *o++=c+1;*o++=c+4;*o++=c+5;goto black;
		case 0x78: *o++=c+1;*o++=c+5;break;
		case 0x79: *o++=c+1;*o++=c+5;*o++=c+7;goto black;
		case 0x7a: *o++=c+1;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x7b: *o++=c+1;*o++=c+5;*o++=c+6;goto black;
		case 0x7c: *o++=c+1;*o++=c+6;break;
		case 0x7d: *o++=c+1;*o++=c+6;*o++=c+7;goto black;
		case 0x7e: *o++=c+1;*o++=c+7;break;
		case 0x7f: *o++=c+1;goto black;
		case 0x80: *o++=c;*o++=c+1;break;
		case 0x81: *o++=c;*o++=c+1;*o++=c+7;goto black;
		case 0x82: *o++=c;*o++=c+1;*o++=c+6;*o++=c+7;break;
		case 0x83: *o++=c;*o++=c+1;*o++=c+6;goto black;
		case 0x84: *o++=c;*o++=c+1;*o++=c+5;*o++=c+6;break;
		case 0x85: *o++=c;*o++=c+1;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0x86: *o++=c;*o++=c+1;*o++=c+5;*o++=c+7;break;
		case 0x87: *o++=c;*o++=c+1;*o++=c+5;goto black;
		case 0x88: *o++=c;*o++=c+1;*o++=c+4;*o++=c+5;break;
		case 0x89: *o++=c;*o++=c+1;*o++=c+4;*o++=c+5;*o++=c+7;goto black;
		case 0x8a: *o++=c;*o++=c+1;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x8b: *o++=c;*o++=c+1;*o++=c+4;*o++=c+5;*o++=c+6;goto black;
		case 0x8c: *o++=c;*o++=c+1;*o++=c+4;*o++=c+6;break;
		case 0x8d: *o++=c;*o++=c+1;*o++=c+4;*o++=c+6;*o++=c+7;goto black;
		case 0x8e: *o++=c;*o++=c+1;*o++=c+4;*o++=c+7;break;
		case 0x8f: *o++=c;*o++=c+1;*o++=c+4;goto black;
		case 0x90: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;break;
		case 0x91: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;*o++=c+7;goto black;
		case 0x92: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0x93: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;*o++=c+6;goto black;
		case 0x94: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0x95: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0x96: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0x97: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;goto black;
		case 0x98: *o++=c;*o++=c+1;*o++=c+3;*o++=c+5;break;
		case 0x99: *o++=c;*o++=c+1;*o++=c+3;*o++=c+5;*o++=c+7;goto black;
		case 0x9a: *o++=c;*o++=c+1;*o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x9b: *o++=c;*o++=c+1;*o++=c+3;*o++=c+5;*o++=c+6;goto black;
		case 0x9c: *o++=c;*o++=c+1;*o++=c+3;*o++=c+6;break;
		case 0x9d: *o++=c;*o++=c+1;*o++=c+3;*o++=c+6;*o++=c+7;goto black;
		case 0x9e: *o++=c;*o++=c+1;*o++=c+3;*o++=c+7;break;
		case 0x9f: *o++=c;*o++=c+1;*o++=c+3;goto black;
		case 0xa0: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;break;
		case 0xa1: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+7;goto black;
		case 0xa2: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+6;*o++=c+7;break;
		case 0xa3: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+6;goto black;
		case 0xa4: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;break;
		case 0xa5: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0xa6: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+7;break;
		case 0xa7: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;goto black;
		case 0xa8: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;break;
		case 0xa9: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;goto black;
		case 0xaa: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0xab: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;goto black;
		case 0xac: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;break;
		case 0xad: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;goto black;
		case 0xae: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+7;break;
		case 0xaf: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;goto black;
		case 0xb0: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;break;
		case 0xb1: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;*o++=c+7;goto black;
		case 0xb2: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0xb3: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;*o++=c+6;goto black;
		case 0xb4: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0xb5: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0xb6: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0xb7: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;goto black;
		case 0xb8: *o++=c;*o++=c+1;*o++=c+2;*o++=c+5;break;
		case 0xb9: *o++=c;*o++=c+1;*o++=c+2;*o++=c+5;*o++=c+7;goto black;
		case 0xba: *o++=c;*o++=c+1;*o++=c+2;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0xbb: *o++=c;*o++=c+1;*o++=c+2;*o++=c+5;*o++=c+6;goto black;
		case 0xbc: *o++=c;*o++=c+1;*o++=c+2;*o++=c+6;break;
		case 0xbd: *o++=c;*o++=c+1;*o++=c+2;*o++=c+6;*o++=c+7;goto black;
		case 0xbe: *o++=c;*o++=c+1;*o++=c+2;*o++=c+7;break;
		case 0xbf: *o++=c;*o++=c+1;*o++=c+2;goto black;
		case 0xc0: *o++=c;*o++=c+2;break;
		case 0xc1: *o++=c;*o++=c+2;*o++=c+7;goto black;
		case 0xc2: *o++=c;*o++=c+2;*o++=c+6;*o++=c+7;break;
		case 0xc3: *o++=c;*o++=c+2;*o++=c+6;goto black;
		case 0xc4: *o++=c;*o++=c+2;*o++=c+5;*o++=c+6;break;
		case 0xc5: *o++=c;*o++=c+2;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0xc6: *o++=c;*o++=c+2;*o++=c+5;*o++=c+7;break;
		case 0xc7: *o++=c;*o++=c+2;*o++=c+5;goto black;
		case 0xc8: *o++=c;*o++=c+2;*o++=c+4;*o++=c+5;break;
		case 0xc9: *o++=c;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+7;goto black;
		case 0xca: *o++=c;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0xcb: *o++=c;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;goto black;
		case 0xcc: *o++=c;*o++=c+2;*o++=c+4;*o++=c+6;break;
		case 0xcd: *o++=c;*o++=c+2;*o++=c+4;*o++=c+6;*o++=c+7;goto black;
		case 0xce: *o++=c;*o++=c+2;*o++=c+4;*o++=c+7;break;
		case 0xcf: *o++=c;*o++=c+2;*o++=c+4;goto black;
		case 0xd0: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;break;
		case 0xd1: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+7;goto black;
		case 0xd2: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0xd3: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;goto black;
		case 0xd4: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0xd5: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0xd6: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0xd7: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;goto black;
		case 0xd8: *o++=c;*o++=c+2;*o++=c+3;*o++=c+5;break;
		case 0xd9: *o++=c;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+7;goto black;
		case 0xda: *o++=c;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0xdb: *o++=c;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;goto black;
		case 0xdc: *o++=c;*o++=c+2;*o++=c+3;*o++=c+6;break;
		case 0xdd: *o++=c;*o++=c+2;*o++=c+3;*o++=c+6;*o++=c+7;goto black;
		case 0xde: *o++=c;*o++=c+2;*o++=c+3;*o++=c+7;break;
		case 0xdf: *o++=c;*o++=c+2;*o++=c+3;goto black;
		case 0xe0: *o++=c;*o++=c+3;break;
		case 0xe1: *o++=c;*o++=c+3;*o++=c+7;goto black;
		case 0xe2: *o++=c;*o++=c+3;*o++=c+6;*o++=c+7;break;
		case 0xe3: *o++=c;*o++=c+3;*o++=c+6;goto black;
		case 0xe4: *o++=c;*o++=c+3;*o++=c+5;*o++=c+6;break;
		case 0xe5: *o++=c;*o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0xe6: *o++=c;*o++=c+3;*o++=c+5;*o++=c+7;break;
		case 0xe7: *o++=c;*o++=c+3;*o++=c+5;goto black;
		case 0xe8: *o++=c;*o++=c+3;*o++=c+4;*o++=c+5;break;
		case 0xe9: *o++=c;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;goto black;
		case 0xea: *o++=c;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0xeb: *o++=c;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;goto black;
		case 0xec: *o++=c;*o++=c+3;*o++=c+4;*o++=c+6;break;
		case 0xed: *o++=c;*o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;goto black;
		case 0xee: *o++=c;*o++=c+3;*o++=c+4;*o++=c+7;break;
		case 0xef: *o++=c;*o++=c+3;*o++=c+4;goto black;
		case 0xf0: *o++=c;*o++=c+4;break;
		case 0xf1: *o++=c;*o++=c+4;*o++=c+7;goto black;
		case 0xf2: *o++=c;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0xf3: *o++=c;*o++=c+4;*o++=c+6;goto black;
		case 0xf4: *o++=c;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0xf5: *o++=c;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto black;
		case 0xf6: *o++=c;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0xf7: *o++=c;*o++=c+4;*o++=c+5;goto black;
		case 0xf8: *o++=c;*o++=c+5;break;
		case 0xf9: *o++=c;*o++=c+5;*o++=c+7;goto black;
		case 0xfa: *o++=c;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0xfb: *o++=c;*o++=c+5;*o++=c+6;goto black;
		case 0xfc: *o++=c;*o++=c+6;break;
		case 0xfd: *o++=c;*o++=c+6;*o++=c+7;goto black;
		case 0xfe: *o++=c;*o++=c+7;break;
		case 0xff: *o++=c;goto black;
		}
		c += 8;
	}
#ifndef PIXCOMPAT
	if (bp >= be) *o++ = width - offset;
#endif
  black:
	c = (bp - input) << 3;
	c -= offset;
	while (bp < be) {
		switch (*bp++) {
		case 0x0: *o++=c;goto white;
		case 0x1: *o++=c;*o++=c+7;break;
		case 0x2: *o++=c;*o++=c+6;*o++=c+7;goto white;
		case 0x3: *o++=c;*o++=c+6;break;
		case 0x4: *o++=c;*o++=c+5;*o++=c+6;goto white;
		case 0x5: *o++=c;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x6: *o++=c;*o++=c+5;*o++=c+7;goto white;
		case 0x7: *o++=c;*o++=c+5;break;
		case 0x8: *o++=c;*o++=c+4;*o++=c+5;goto white;
		case 0x9: *o++=c;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0xa: *o++=c;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0xb: *o++=c;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0xc: *o++=c;*o++=c+4;*o++=c+6;goto white;
		case 0xd: *o++=c;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0xe: *o++=c;*o++=c+4;*o++=c+7;goto white;
		case 0xf: *o++=c;*o++=c+4;break;
		case 0x10: *o++=c;*o++=c+3;*o++=c+4;goto white;
		case 0x11: *o++=c;*o++=c+3;*o++=c+4;*o++=c+7;break;
		case 0x12: *o++=c;*o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;goto white;
		case 0x13: *o++=c;*o++=c+3;*o++=c+4;*o++=c+6;break;
		case 0x14: *o++=c;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;goto white;
		case 0x15: *o++=c;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x16: *o++=c;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;goto white;
		case 0x17: *o++=c;*o++=c+3;*o++=c+4;*o++=c+5;break;
		case 0x18: *o++=c;*o++=c+3;*o++=c+5;goto white;
		case 0x19: *o++=c;*o++=c+3;*o++=c+5;*o++=c+7;break;
		case 0x1a: *o++=c;*o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0x1b: *o++=c;*o++=c+3;*o++=c+5;*o++=c+6;break;
		case 0x1c: *o++=c;*o++=c+3;*o++=c+6;goto white;
		case 0x1d: *o++=c;*o++=c+3;*o++=c+6;*o++=c+7;break;
		case 0x1e: *o++=c;*o++=c+3;*o++=c+7;goto white;
		case 0x1f: *o++=c;*o++=c+3;break;
		case 0x20: *o++=c;*o++=c+2;*o++=c+3;goto white;
		case 0x21: *o++=c;*o++=c+2;*o++=c+3;*o++=c+7;break;
		case 0x22: *o++=c;*o++=c+2;*o++=c+3;*o++=c+6;*o++=c+7;goto white;
		case 0x23: *o++=c;*o++=c+2;*o++=c+3;*o++=c+6;break;
		case 0x24: *o++=c;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;goto white;
		case 0x25: *o++=c;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x26: *o++=c;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+7;goto white;
		case 0x27: *o++=c;*o++=c+2;*o++=c+3;*o++=c+5;break;
		case 0x28: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;goto white;
		case 0x29: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0x2a: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0x2b: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0x2c: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;goto white;
		case 0x2d: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0x2e: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+7;goto white;
		case 0x2f: *o++=c;*o++=c+2;*o++=c+3;*o++=c+4;break;
		case 0x30: *o++=c;*o++=c+2;*o++=c+4;goto white;
		case 0x31: *o++=c;*o++=c+2;*o++=c+4;*o++=c+7;break;
		case 0x32: *o++=c;*o++=c+2;*o++=c+4;*o++=c+6;*o++=c+7;goto white;
		case 0x33: *o++=c;*o++=c+2;*o++=c+4;*o++=c+6;break;
		case 0x34: *o++=c;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;goto white;
		case 0x35: *o++=c;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x36: *o++=c;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+7;goto white;
		case 0x37: *o++=c;*o++=c+2;*o++=c+4;*o++=c+5;break;
		case 0x38: *o++=c;*o++=c+2;*o++=c+5;goto white;
		case 0x39: *o++=c;*o++=c+2;*o++=c+5;*o++=c+7;break;
		case 0x3a: *o++=c;*o++=c+2;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0x3b: *o++=c;*o++=c+2;*o++=c+5;*o++=c+6;break;
		case 0x3c: *o++=c;*o++=c+2;*o++=c+6;goto white;
		case 0x3d: *o++=c;*o++=c+2;*o++=c+6;*o++=c+7;break;
		case 0x3e: *o++=c;*o++=c+2;*o++=c+7;goto white;
		case 0x3f: *o++=c;*o++=c+2;break;
		case 0x40: *o++=c;*o++=c+1;*o++=c+2;goto white;
		case 0x41: *o++=c;*o++=c+1;*o++=c+2;*o++=c+7;break;
		case 0x42: *o++=c;*o++=c+1;*o++=c+2;*o++=c+6;*o++=c+7;goto white;
		case 0x43: *o++=c;*o++=c+1;*o++=c+2;*o++=c+6;break;
		case 0x44: *o++=c;*o++=c+1;*o++=c+2;*o++=c+5;*o++=c+6;goto white;
		case 0x45: *o++=c;*o++=c+1;*o++=c+2;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x46: *o++=c;*o++=c+1;*o++=c+2;*o++=c+5;*o++=c+7;goto white;
		case 0x47: *o++=c;*o++=c+1;*o++=c+2;*o++=c+5;break;
		case 0x48: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;goto white;
		case 0x49: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0x4a: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0x4b: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0x4c: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;*o++=c+6;goto white;
		case 0x4d: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0x4e: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;*o++=c+7;goto white;
		case 0x4f: *o++=c;*o++=c+1;*o++=c+2;*o++=c+4;break;
		case 0x50: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;goto white;
		case 0x51: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+7;break;
		case 0x52: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;goto white;
		case 0x53: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;break;
		case 0x54: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;goto white;
		case 0x55: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x56: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;goto white;
		case 0x57: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;break;
		case 0x58: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;goto white;
		case 0x59: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+7;break;
		case 0x5a: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0x5b: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;break;
		case 0x5c: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+6;goto white;
		case 0x5d: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+6;*o++=c+7;break;
		case 0x5e: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;*o++=c+7;goto white;
		case 0x5f: *o++=c;*o++=c+1;*o++=c+2;*o++=c+3;break;
		case 0x60: *o++=c;*o++=c+1;*o++=c+3;goto white;
		case 0x61: *o++=c;*o++=c+1;*o++=c+3;*o++=c+7;break;
		case 0x62: *o++=c;*o++=c+1;*o++=c+3;*o++=c+6;*o++=c+7;goto white;
		case 0x63: *o++=c;*o++=c+1;*o++=c+3;*o++=c+6;break;
		case 0x64: *o++=c;*o++=c+1;*o++=c+3;*o++=c+5;*o++=c+6;goto white;
		case 0x65: *o++=c;*o++=c+1;*o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x66: *o++=c;*o++=c+1;*o++=c+3;*o++=c+5;*o++=c+7;goto white;
		case 0x67: *o++=c;*o++=c+1;*o++=c+3;*o++=c+5;break;
		case 0x68: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;goto white;
		case 0x69: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0x6a: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0x6b: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0x6c: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;*o++=c+6;goto white;
		case 0x6d: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0x6e: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;*o++=c+7;goto white;
		case 0x6f: *o++=c;*o++=c+1;*o++=c+3;*o++=c+4;break;
		case 0x70: *o++=c;*o++=c+1;*o++=c+4;goto white;
		case 0x71: *o++=c;*o++=c+1;*o++=c+4;*o++=c+7;break;
		case 0x72: *o++=c;*o++=c+1;*o++=c+4;*o++=c+6;*o++=c+7;goto white;
		case 0x73: *o++=c;*o++=c+1;*o++=c+4;*o++=c+6;break;
		case 0x74: *o++=c;*o++=c+1;*o++=c+4;*o++=c+5;*o++=c+6;goto white;
		case 0x75: *o++=c;*o++=c+1;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x76: *o++=c;*o++=c+1;*o++=c+4;*o++=c+5;*o++=c+7;goto white;
		case 0x77: *o++=c;*o++=c+1;*o++=c+4;*o++=c+5;break;
		case 0x78: *o++=c;*o++=c+1;*o++=c+5;goto white;
		case 0x79: *o++=c;*o++=c+1;*o++=c+5;*o++=c+7;break;
		case 0x7a: *o++=c;*o++=c+1;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0x7b: *o++=c;*o++=c+1;*o++=c+5;*o++=c+6;break;
		case 0x7c: *o++=c;*o++=c+1;*o++=c+6;goto white;
		case 0x7d: *o++=c;*o++=c+1;*o++=c+6;*o++=c+7;break;
		case 0x7e: *o++=c;*o++=c+1;*o++=c+7;goto white;
		case 0x7f: *o++=c;*o++=c+1;break;
		case 0x80: *o++=c+1;goto white;
		case 0x81: *o++=c+1;*o++=c+7;break;
		case 0x82: *o++=c+1;*o++=c+6;*o++=c+7;goto white;
		case 0x83: *o++=c+1;*o++=c+6;break;
		case 0x84: *o++=c+1;*o++=c+5;*o++=c+6;goto white;
		case 0x85: *o++=c+1;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x86: *o++=c+1;*o++=c+5;*o++=c+7;goto white;
		case 0x87: *o++=c+1;*o++=c+5;break;
		case 0x88: *o++=c+1;*o++=c+4;*o++=c+5;goto white;
		case 0x89: *o++=c+1;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0x8a: *o++=c+1;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0x8b: *o++=c+1;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0x8c: *o++=c+1;*o++=c+4;*o++=c+6;goto white;
		case 0x8d: *o++=c+1;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0x8e: *o++=c+1;*o++=c+4;*o++=c+7;goto white;
		case 0x8f: *o++=c+1;*o++=c+4;break;
		case 0x90: *o++=c+1;*o++=c+3;*o++=c+4;goto white;
		case 0x91: *o++=c+1;*o++=c+3;*o++=c+4;*o++=c+7;break;
		case 0x92: *o++=c+1;*o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;goto white;
		case 0x93: *o++=c+1;*o++=c+3;*o++=c+4;*o++=c+6;break;
		case 0x94: *o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;goto white;
		case 0x95: *o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0x96: *o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;goto white;
		case 0x97: *o++=c+1;*o++=c+3;*o++=c+4;*o++=c+5;break;
		case 0x98: *o++=c+1;*o++=c+3;*o++=c+5;goto white;
		case 0x99: *o++=c+1;*o++=c+3;*o++=c+5;*o++=c+7;break;
		case 0x9a: *o++=c+1;*o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0x9b: *o++=c+1;*o++=c+3;*o++=c+5;*o++=c+6;break;
		case 0x9c: *o++=c+1;*o++=c+3;*o++=c+6;goto white;
		case 0x9d: *o++=c+1;*o++=c+3;*o++=c+6;*o++=c+7;break;
		case 0x9e: *o++=c+1;*o++=c+3;*o++=c+7;goto white;
		case 0x9f: *o++=c+1;*o++=c+3;break;
		case 0xa0: *o++=c+1;*o++=c+2;*o++=c+3;goto white;
		case 0xa1: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+7;break;
		case 0xa2: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+6;*o++=c+7;goto white;
		case 0xa3: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+6;break;
		case 0xa4: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;goto white;
		case 0xa5: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0xa6: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;*o++=c+7;goto white;
		case 0xa7: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+5;break;
		case 0xa8: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;goto white;
		case 0xa9: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0xaa: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0xab: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0xac: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;goto white;
		case 0xad: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0xae: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;*o++=c+7;goto white;
		case 0xaf: *o++=c+1;*o++=c+2;*o++=c+3;*o++=c+4;break;
		case 0xb0: *o++=c+1;*o++=c+2;*o++=c+4;goto white;
		case 0xb1: *o++=c+1;*o++=c+2;*o++=c+4;*o++=c+7;break;
		case 0xb2: *o++=c+1;*o++=c+2;*o++=c+4;*o++=c+6;*o++=c+7;goto white;
		case 0xb3: *o++=c+1;*o++=c+2;*o++=c+4;*o++=c+6;break;
		case 0xb4: *o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;goto white;
		case 0xb5: *o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0xb6: *o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;*o++=c+7;goto white;
		case 0xb7: *o++=c+1;*o++=c+2;*o++=c+4;*o++=c+5;break;
		case 0xb8: *o++=c+1;*o++=c+2;*o++=c+5;goto white;
		case 0xb9: *o++=c+1;*o++=c+2;*o++=c+5;*o++=c+7;break;
		case 0xba: *o++=c+1;*o++=c+2;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0xbb: *o++=c+1;*o++=c+2;*o++=c+5;*o++=c+6;break;
		case 0xbc: *o++=c+1;*o++=c+2;*o++=c+6;goto white;
		case 0xbd: *o++=c+1;*o++=c+2;*o++=c+6;*o++=c+7;break;
		case 0xbe: *o++=c+1;*o++=c+2;*o++=c+7;goto white;
		case 0xbf: *o++=c+1;*o++=c+2;break;
		case 0xc0: *o++=c+2;goto white;
		case 0xc1: *o++=c+2;*o++=c+7;break;
		case 0xc2: *o++=c+2;*o++=c+6;*o++=c+7;goto white;
		case 0xc3: *o++=c+2;*o++=c+6;break;
		case 0xc4: *o++=c+2;*o++=c+5;*o++=c+6;goto white;
		case 0xc5: *o++=c+2;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0xc6: *o++=c+2;*o++=c+5;*o++=c+7;goto white;
		case 0xc7: *o++=c+2;*o++=c+5;break;
		case 0xc8: *o++=c+2;*o++=c+4;*o++=c+5;goto white;
		case 0xc9: *o++=c+2;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0xca: *o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0xcb: *o++=c+2;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0xcc: *o++=c+2;*o++=c+4;*o++=c+6;goto white;
		case 0xcd: *o++=c+2;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0xce: *o++=c+2;*o++=c+4;*o++=c+7;goto white;
		case 0xcf: *o++=c+2;*o++=c+4;break;
		case 0xd0: *o++=c+2;*o++=c+3;*o++=c+4;goto white;
		case 0xd1: *o++=c+2;*o++=c+3;*o++=c+4;*o++=c+7;break;
		case 0xd2: *o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;goto white;
		case 0xd3: *o++=c+2;*o++=c+3;*o++=c+4;*o++=c+6;break;
		case 0xd4: *o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;goto white;
		case 0xd5: *o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0xd6: *o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;goto white;
		case 0xd7: *o++=c+2;*o++=c+3;*o++=c+4;*o++=c+5;break;
		case 0xd8: *o++=c+2;*o++=c+3;*o++=c+5;goto white;
		case 0xd9: *o++=c+2;*o++=c+3;*o++=c+5;*o++=c+7;break;
		case 0xda: *o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0xdb: *o++=c+2;*o++=c+3;*o++=c+5;*o++=c+6;break;
		case 0xdc: *o++=c+2;*o++=c+3;*o++=c+6;goto white;
		case 0xdd: *o++=c+2;*o++=c+3;*o++=c+6;*o++=c+7;break;
		case 0xde: *o++=c+2;*o++=c+3;*o++=c+7;goto white;
		case 0xdf: *o++=c+2;*o++=c+3;break;
		case 0xe0: *o++=c+3;goto white;
		case 0xe1: *o++=c+3;*o++=c+7;break;
		case 0xe2: *o++=c+3;*o++=c+6;*o++=c+7;goto white;
		case 0xe3: *o++=c+3;*o++=c+6;break;
		case 0xe4: *o++=c+3;*o++=c+5;*o++=c+6;goto white;
		case 0xe5: *o++=c+3;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0xe6: *o++=c+3;*o++=c+5;*o++=c+7;goto white;
		case 0xe7: *o++=c+3;*o++=c+5;break;
		case 0xe8: *o++=c+3;*o++=c+4;*o++=c+5;goto white;
		case 0xe9: *o++=c+3;*o++=c+4;*o++=c+5;*o++=c+7;break;
		case 0xea: *o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0xeb: *o++=c+3;*o++=c+4;*o++=c+5;*o++=c+6;break;
		case 0xec: *o++=c+3;*o++=c+4;*o++=c+6;goto white;
		case 0xed: *o++=c+3;*o++=c+4;*o++=c+6;*o++=c+7;break;
		case 0xee: *o++=c+3;*o++=c+4;*o++=c+7;goto white;
		case 0xef: *o++=c+3;*o++=c+4;break;
		case 0xf0: *o++=c+4;goto white;
		case 0xf1: *o++=c+4;*o++=c+7;break;
		case 0xf2: *o++=c+4;*o++=c+6;*o++=c+7;goto white;
		case 0xf3: *o++=c+4;*o++=c+6;break;
		case 0xf4: *o++=c+4;*o++=c+5;*o++=c+6;goto white;
		case 0xf5: *o++=c+4;*o++=c+5;*o++=c+6;*o++=c+7;break;
		case 0xf6: *o++=c+4;*o++=c+5;*o++=c+7;goto white;
		case 0xf7: *o++=c+4;*o++=c+5;break;
		case 0xf8: *o++=c+5;goto white;
		case 0xf9: *o++=c+5;*o++=c+7;break;
		case 0xfa: *o++=c+5;*o++=c+6;*o++=c+7;goto white;
		case 0xfb: *o++=c+5;*o++=c+6;break;
		case 0xfc: *o++=c+6;goto white;
		case 0xfd: *o++=c+6;*o++=c+7;break;
		case 0xfe: *o++=c+7;goto white;
		case 0xff: break;
		}
		c += 8;
	}
	*o++ = width - offset;
	*o = -1;
	return o - run;
  speed:
	while (!*(unsigned long *)bp && bp < be) bp += 4;
	if (bp < be) goto white;
#ifndef PIXCOMPAT
	*o++ = width - offset;
#endif
	*o++ = width - offset;
	*o = -1;
	return o - run;
}

#endif
