#include "dafs.h"
#include <stdio.h>
#include "ifc.h"
#include "smemory.h"

ifc myargs[] = {
        {0, 0,0, 1, IFC_NA, 0, 0}
};

usage(char *p)
{
        fprintf(stderr,"usage: %s <dafs files>\n",p);
        exit(1);
}

int
readblock(char *tmp_buf,FILE *fp,int *tot_size)
{
	short sz;
	int num,j;

	while(!feof(fp)){	
		/*read in the size of the block, then the block*/
		fread((char*)&sz+1,1,1,fp);
		fread(&sz,1,1,fp);
		num=sz;
		
		fread(tmp_buf,1,num,fp);
		tmp_buf+=num;
		(*tot_size)+=num;
		if(num<2048) return 0;
	}
	return 0;
}
int 
decompress (char *obuf, char *buf, int insize,int *tot_size) {

	unsigned short size;
	char *inend,*ocur;
	
	inend = buf+insize;
	ocur = obuf;
	while(buf < inend){
		while (buf < inend && (*ocur++ = *buf++)) ;
		if (buf >= inend) break;
		if (!(size = *(unsigned char*)buf++)) {
			*((char*)&size+1)=*buf++;
			*((char*)&size)=*buf++;
		}
		if (size>*tot_size )
			printf("something wrong\n");
			
		ocur=memset(ocur,0,size--);
		ocur += size;
	}		
	*tot_size = ocur-obuf;
	return 0;
}	
int swaprow(char *buf, int size) {
	char *beg, *end,tmp;
	
	beg=buf;
	end=&buf[size];
		tmp	= *beg;
		*beg = *end;
		*end = tmp;
	size /=2;
	while (beg != end){
		tmp	= *beg;
		*beg = *end;
		*end = tmp;
		beg++;end--;
	}
	tmp	= *beg;
	*beg = *end;
	*end = tmp;
}
		
	
int main(int c, char *v[]) 
{
    iDAFSError e=DAFSOK;
	iImagePtr im,im2;
	iEntityPtr doc;
	char *buf,*temp_buf,*extv[]={".tst",".dz",".bal",""}, iname[100],oname[100];
	short sz;
	FILE *fp;
	char hd[1024];
	iBox b={0,0,0,0};
	int tot_size,size,i,j;

	s_InitLib(0,0,0);
	i_InitLib();
	
	if (processargs(c, v, myargs))
	        usage(v[0]);
	temp_buf=(char*)smalloc(1024000);
	buf=(char*)smalloc(1024000);
	if(!buf || !temp_buf) halt("Failed to malloc\n");
 	stripext(c,v,extv);
	
    for (i=1;i<c;i++) 
	{
	    if (!v[i])
	            continue; 
	   sprintf(iname,"%s%s",v[i],extv[0]);
	   fp=fopen(iname,"rb");
		
		/*read in the size of the header, then the header*/	
		if (!fread((char*)&sz+1,1,1,fp))
			printf("failed to read header size\n");
		if (!fread(&sz,1,1,fp))
			printf("failed to read more of header size\n");
		if (sz!=fread(hd,1,sz,fp))
			printf("failed to read header\n");
		tot_size=0;
		
		
		readblock(temp_buf,fp,&tot_size);
		size=tot_size;
		decompress(buf,temp_buf,size,&tot_size);
		printf("the total num of bytes are: %d \n",tot_size);
		b.x=0;
		b.y=0;
	    b.w=512;

		b.h=tot_size/64;
		for(j=0;j<tot_size;j+=64){
			swaprow(&buf[j],64);
		}
		im=i_BitMap2Image(b,64,buf);
		e=i_RotateImage(im,90);
		b.w=i_GetImageWidth(im);
		b.h=i_GetImageHeight(im);
		doc=i_NewEntity(iDocumentT,0);
		i_SetBox(doc,b);
		i_SetImage(doc,im);
		sprintf(oname,"%s%s",v[i],extv[1]);
		printf("writing file %s\n",oname);
		e=i_WriteEntity(oname,doc,DAFSB);
	        if(e) printf("error in write file:%s\n",oname);
	   i_DisposeImage(im);
		i_DisposeEntity(doc);

		fclose(fp);
	}
	smfree(buf);
	smfree(temp_buf);
	i_ExitLib();
	s_ExitLib();
	return 0;
}
