
#include <stdio.h>
#include "rafport.h"

#include "rafutil.h"

#include "smemory.h"
#include "ifc.h"
#include "dafs.h"

int memcheck;
int print;
char *filename; 

static ifc myargs[] = {
	{(char **) &memcheck,0,0,7,IFC_INT,"s",0},
	{(char **) &print,0,0,1,IFC_FLAG,"p",0},
	{0, 0,0, 1, IFC_NA, 0, 0}
};

static void usage(char *p)
{
	fprintf(stderr, "Usage: %s [-z] input ...\n",p);
	exit(-1);
}

int
main(int c, char *v[])
{
	int i,beg=0,size;
	iDAFSError e;
	iEntityPtr doc,old;
	char name[100],buf[100];
	char *extv[] = {".txt",".dz",".ds",".dt",".dr",""};
	FILE *fo;
	int type;

	if (processargs(c, v, myargs))
		usage(v[0]);

	s_InitLib(memcheck, 0, 0);
	i_InitLib();
	type=stripext(c,v,extv);
	for (i = 1; i < c; i++) {
		if (!v[i])
			continue;
		printf("reading %s\n",v[i]);
		sprintf(name,"%s%s",v[i],extv[type]);
		e=i_ReadEntity(name,&doc);
		if (e) {
			fprintf(stderr,"couldn't open %s\n", name);
			continue;
		}
		sprintf(name,"%s%s",v[i],extv[0]);
		if(print)
			fo=stdout;
		else
			fo=fopen(name,"w");
		old=doc;
#if 0
		while(doc){
			size=100;

			/* used to have error where suppressed final newline */
			e=i_Dafs2Text(&doc,&beg,buf,&size,0);
			if(doc) 
				fwrite(buf,1,100,fo);
			else 
				fwrite(buf,1,strlen(buf),fo);


		}
#else 
		{
			char *s;
			s = i_AllocASCIIText(doc, 0);
			fwrite(s,1,strlen(s), fo);
			smfree(s);
		}
#endif
		fclose(fo);
		i_DisposeEntity(old);
		if (e) halt("couldn't convert doc\n");
	}
	i_ExitLib();
	s_ExitLib();
	return 0;
}
