
#include <stdio.h>
#include "rafport.h"

#include "smemory.h"

#include "ifc.h"
#include "dafs.h"
#include "debug.h"

static int memcheck;
static char *level;

static ifc myargs[] = {
	{(char **) &memcheck,0,0,999,IFC_INT,"s",0},
	{(char **) &level,0,0,0,IFC_STR,"p",0},
	{0, 0, 0, 1, IFC_NA, 0, 0}
};

static void
usage(char *p)
{
	fprintf(stderr, "Usage: %s <dafsfile>* ...\n",p);
	fprintf(stderr, "-p\"Type\"\n");
	fprintf(stderr, "-s\"memcheck\"\n");
	exit(-1); 
}

int
main(int c, char *v[])
{
	int i;
	iDAFSError e;
	iEntityPtr doc;
	
	s_InitLib(memcheck, 0, 0);
	i_InitLib();

	if (processargs(c, v, myargs))
		usage(v[0]);

	for (i = 1; i < c; i++) {
		if (!v[i])
			continue;
		e = i_ReadEntity(v[i],&doc);
		if (e) {
			fprintf(stderr,"couldn't open %s\n", v[i]);
			if(doc)
				i_DisposeEntity(doc);
			continue;
		}

		if (level) {
			iTypeIndex ind;
			e = i_NameToType(level, &ind);
			if(!e)
				prnchild(doc,ind);
			else {
				fprintf(stderr,"couldn't convert level %s\n", level);
				return -1;
			}
		}
		else 
			prall(doc);

		i_DisposeEntity(doc);
	}

	i_ExitLib();
	s_ExitLib();
	return 0;
}
