
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _CE_h_
#define _CE_h_

/*
// the EntityFace that represents entities in OOC mode and Flag mode
*/

#include "illum.h"

#include "text/EntityFace.h"

// defined in CE.cc
int bloatOOCBox(iBox *b,int type);

// what is this define and why is it here
#define CELL_MARGIN 16

class CE : public EntityFace {
  private:
	int sub_page;
	unsigned short x; // are these shorts already ??
	unsigned short y;
	
public:
	CE(OOCPage *page, iEntityPtr entity);
private:
	virtual ~CE();   // to make sure that I control when it is called
public:
	/*virtual*/ void deleteAndUpdate();
	/*virtual*/ void deleteCheap();
	
	void blankGhost(); // when we are deleted or moved somewhere else

	// calls redisplay after manufacturing args
	void redrawCell();
	void redisplay(Display *, Pixmap, ViewCanvas *, int x_offset, int y_offset, 
				   int cell_width, int cell_height);

	void assignPosition(int sub_page, Position x, Position y);
	iBox computeBounds();
	
	// virtual functions that indirectly respond to dafslib messages
	// defined initially in EntityFace
	/*virtual*/ void create();
	/*virtual*/ void destroy();
	/*virtual*/ void willUpdate();
	/*virtual*/ void update();
	/*virtual*/ void willMove();
	/*virtual*/ void move();
	/*virtual*/ void select();
	/*virtual*/ void unSelect();
	/*virtual*/ void recognize();
	/*virtual*/ MainWindow *getMainWindow();

	friend class OOCPage;
};

#endif
