
/*
 * Copyright (c) 1994, 1995 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _EntityDialog_h_
#define _EntityDialog_h_

#include "illum.h"
#include "misc/misc.h"
#include "aString.h"

struct XmSelectionBoxCallbackStruct;
struct XmDrawingAreaCallbackStruct;


#include "Dialog.h" // we are subclassed
class EntContentDialog;
class PropContentDialog;

class EntityDialog : public Dialog {
  public:
	EntContentDialog *posset_dialog;
	PropContentDialog *prop_dialog;
	iEntityPtr entity;
  private:
	int index;

	iEntityPtr next_entity;
	int next_index;

	// my data
	aString current_title;
	
	Widget rowcol,pbblab;
	Widget bounds[4],pbounds[4];
	
	Widget type_field,typetext;
	Widget prop_field,proplab;
	Widget data_text_field, data_list_field;
	Widget data_label, data_holder;
	Widget draw, rcframe;
	MenuItem *entity_popup;
	int dirtyview;
	
	void drawImageNow(Region r);
	void makeView();
	void chooseType();

	void doView();

	void setTitle();
  public:
	EntityDialog(MainWindow *mw, Widget app_shell);
	~EntityDialog();

	/*virtual*/ void create();
	void setEntity(iEntityPtr entity, int index);
	void setCursor(iEntityPtr next_entity, int next_index);
	void updateTypes();  // update type table when new entity is read

	// these are misleading -- why do you think we are handing
	// in an entity if we want to update or clear the one there?
	// because we are only clearing that entity it matches this one
	void updateEntity(iEntityPtr entity);
	void clearEntity(iEntityPtr entity);

	friend void PopupCB(Widget w,
							   EntityDialog *tf,
							   XmDrawingAreaCallbackStruct *cbs);

	friend void 	chooseIt(Widget w,
								 EntityDialog *ev,
								 XmAnyCallbackStruct *cbs);

	friend void setSensitive(EntityDialog *ev, int sens);
	friend void editData(Widget w, void *user_data, XmAnyCallbackStruct * cbs);
	friend void editProp(Widget w, void *user_data, XmAnyCallbackStruct * cbs);
};

#endif
