
/*
 * Copyright (c) 1994, 1995 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _HierPage_h_
#define _HierPage_h_


#include "Page.h"

class HE;

class HierPage : public Page {
  public:
	int stale,ch;
private:
	int maxlev,maxlen,nlines,cw,asc;
	void initHEs(iEntityPtr en,int ind,int shown);
	void updateHEs(iEntityPtr en);
	int drawentities(Display *display,Pixmap pixmap,GC gc,
		iLBox *bp,iEntityPtr en);
	iEntityPtr FindEntity(iEntityPtr,int);
	void delHEs(iEntityPtr en);

public:
	iEntityPtr root_entity;
	int initialized_canvas;

	HierPage(Mode *input_mode, const aString& label, iEntityPtr entity);
	virtual ~HierPage();
	
	void refreshSel(iEntityPtr en);
	int containsSelection(iEntityPtr en);
	void changeEntity(iEntityPtr en);
	/*virtual*/ void conditionallyInitialiseCanvas();
	/*virtual*/ void setMag(int new_mag, int old_mag);
	/*virtual*/ void _setMag(int new_mag, int old_mag);
	/*virtual*/ void redisplay(XmDrawingAreaCallbackStruct *call_data);
	/*virtual void resize(XmDrawingAreaCallbackStruct *call_data); */
	/*virtual*/ iEntityPtr findEnclosingEntity(int x, int y);
	
	/*virtual*/ void addNewEntity(iEntityPtr entity);
	
	/*virtual*/ void prevEntity();
	/*virtual*/ void nextEntity();

	/*virtual*/ void findNextFlagEntity();
	
	/*virtual*/ void upEntity();
	/*virtual*/ void downEntity();
	
	/*virtual*/ void centerOnSelected(iEntityPtr entity);
	/*virtual*/ void scrollToUpperLeft(iEntityPtr entity){};
	
	// for delayed drawing
	/*virtual*/ int resizeNecessaryP();
	/*virtual*/ void drawRegionNow(iLBox box);

	/*virtual void setPicture(iLBox b);*/
	/*virtual iLBox getPicture();*/
	

	/*virtual*/ int pressKey(iUCode key_value);
	
	/*virtual*/ void         pressButton(XEvent *event);
	/*virtual*/ void         releaseButton(XEvent *event);
	/*virtual*/ void         moveButton(int state, int x, int y);
	
	/*virtual*/ void manage();
	/*virtual*/ void unmanage();
};

#endif
