
#include "rafport.h"
#include "rafutil.h"

#include "MainWindow.h"
#include "SelectionManager.h"
#include "IllEditor.h"
#include "ViewCanvas.h"
#include "keyboard/KeyBoard.h"
#include "misc/XArg.h"

IllEditor::IllEditor(Canvas *input_canvas, 
					 int input_scroll_flag,
					 MainWindow *input_mw)
  : UniEditor(input_canvas, input_scroll_flag),
    mw(input_mw) 
{
  Widget canvas_widget = this->getWidget();
  XArg args;
	
args.reset();
args.setArg(XmNbackground, &background_color);
args.getValues(mw->view_canvas->canvas);
	
  XGCValues gcv;
  gcv.foreground = BlackPixelOfScreen(XtScreen(canvas_widget));
  gcv.background = background_color;
  
  XChangeGC(XtDisplay(canvas_widget), this->gc,
	    GCForeground | GCBackground, &gcv);

  if(input_scroll_flag) {
      Widget clip_window, scrolled_window = XtParent(XtParent(canvas_widget));
      XtVaGetValues(scrolled_window, XmNclipWindow, &clip_window, NULL);
  }
}

IllEditor::~IllEditor()
{
}

KeyMap *IllEditor::getKM() 
{ 
  return mw->kb->key_map; 
}
