
/*
 * Copyright (c) 1994, 1995 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _ImageMode_h
#define _ImageMode_h

#include <X11/StringDefs.h>
#include <X11/Intrinsic.h> 
#include <X11/Xutil.h>

#include "illum.h"
#include "dllist.h"
#include "svpmap.h"

#include "Mode.h"

class ImagePage;

class ImageMode : public Mode {
public:
	ImageMode(MainWindow *main_window, iEntityPtr root_entity);
	virtual ~ImageMode();
	
	/*virtual*/ void createPages(iEntityPtr root_entity);
	void findImagesSub(iEntityPtr entity, stringVoidPtrMap *map, DLList *image_list);
	void findImages(iEntityPtr root_entity, DLList *image_list);
	void createPages(DLList *image_list, DLList *entity_list);
	// called if entity has changed
	void reconsider(iEntityPtr entity);
	
	/*virtual*/ void imageDeleted(iImagePtr image);
	
	/*virtual*/ inline aString getName() { return "Image"; }
	/*virtual*/ ModeType getMode() { return vtIMAGE; }
	
	/*virtual*/ void centerOnSelected(iEntityPtr entity);
	/*virtual*/ void addNewEntity(iEntityPtr new_entity);
	
	/*virtual*/ void choose(int buttons_changed);
	
	/*virtual*/ iBox getBounds(iEntityPtr entity);
};


#endif
