#ifndef _RTEUniEditor_h_

#include "RTElement.h"
#include "IllEditor.h"

class RTEUniEditor : public IllEditor
{
protected:
  RTElement *parent_element;
public:
  RTEUniEditor(Canvas *canvas, 
			   int scroll_flag,
			   MainWindow *input_mw,
			   RTElement *parent);
  /*virtual*/ void setSize(int w, int h);

  /*virtual*/ int setCursor(int line, int column);
  /*virtual*/ int setSelection(int begin_line, int begin_column, int end_line, int end_column);
  /*virtual*/ int clearSelection(void);

  void convertLine2DAFS(int line_index, int column, 
						iEntityPtr *entity_ptr, int *index_ptr);
  int convertDAFS2Line(iEntityPtr entity, int index,
						int *line_index, int *column);
  int pressKey(iUCode c);
  void processDelete(void);

  /*virtual*/ int isVisible(int x, int y);
  /*virtual*/ void centerOnCoord(int x, int y);
  /*virtual*/ void calculateVisible(int *first, int *last);
  void getBasePosition(Position *x, Position *y);

public:
  void compare();
};

#endif

