
#include "rafport.h"
#include "illum.h"
#include "dllist.h"

#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <X11/Core.h>
#include <X11/CoreP.h>

#include "misc/XArg.h"

void
_pr1w(Widget w)
{
  XArg args;
  Dimension wi, he;
  Position x, y;
  args.reset();
  args.setArg(XmNwidth, &wi);
  args.setArg(XmNheight, &he);
  args.setArg(XmNx, &x);
  args.setArg(XmNy, &y);
  args.getValues(w);
  printf("%s (%d,%d) %dx%d", w->core.widget_class->core_class.class_name,
		 x, y, wi, he);
}

void
pr1w(Widget w)
{
  _pr1w(w);
  printf("\n");
}

void
printList(DLList *l)
{
	Ref r;
	for(r = dllistFirst(l); r; dllistNext(l, &r)){
		printf("%d\n", r);
	}
}


#ifdef TEXTDEBUG
void prent(iEntityPtr entity)
{	short srt, conf;
	int i;

	switch(i_GetEntityType(entity)){

		case iSpaceT:
			srt=(short)i_GetShort(entity,&conf);
			for(i=0; i<srt; i++)
				printf(" ");
			return;
		case iNewLineT:
			printf("-nl-\n");
			return;
		default:
			break;
	}
	const iPosSet *ps;
	iPosSet mini_ps;
	int2 n;
	iUCode c;
	const char *temp;
	char *foo;
	
	switch(i_GetEDataType(entity)) {
    case iDPosSet:
		ps = i_GetPosSet(entity, &n);
		if (n==0) {
			mini_ps.chr=NON_REC_CHAR;
			ps=&mini_ps;
			n=1;
		}
		foo=(char *)smalloc(sizeof(char)*(n+1));
		if (!foo) halt("Can't allocate memory");
		for(i = 0; i < n; i++)
			foo[i]=ps[i].chr;
		foo[n]=0;
		break;
    case iDString:
		temp = i_GetText(entity,0);
		if(!temp || temp[0]==0) {
			foo=(char *)smalloc(sizeof(char)*(2));
			if (!foo) halt("Can't allocate memory");
			foo[0]=c;
			foo[1]=0;
		} else {
			foo=(char *)smalloc(sizeof(char)*(strlen(temp)+1));
			if (!foo) halt("Can't allocate memory");
			strcpy(temp,foo);
		}
		break;
    case iD1PosSet:
		c = i_GetGlyph(entity,0);
		if(c == 0) c=NON_REC_CHAR;
		foo=(char *)smalloc(sizeof(char)*(2));
		if (!foo)
			halt("Can't allocate memory");
		foo[0]=c;
		foo[1]=0;
		break;
	case iDUniString:
		foo = (char*)smalloc(sizeof(char)*entity->data->num);
		if (!foo)
			halt("Can't allocate memory");
		for(i=0; i<entity->data->num; i++)
			foo[i]=(char)entity->data->d.unitext[i];
		break;
    default:
		foo=NULL;
		break;
	}
	
	printf("%s", foo);
	smfree(foo);
}
			
			
#endif
