
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _c_type_h_
#define _c_type_h_

#include "rafport.h"

/*
// a porting layer on top of the normal ctype.h
*/

#ifdef SYS_OS_SUNOS
char toupper(char);
#ifndef tolower
char tolower(char);
#endif
#endif


#if defined(SYS_TRUESCAN) 
/* bogus -- have to have a better definition */

#if 0
extern int4 isalpha(char c);
extern int4 isupper(char c);
extern int4 islower(char c);
extern char tolower(char c);
extern int4 isascii(char c);
extern int4 isdigit(char c);
#endif


#define isalpha(c) (   (   ((c) >= 'a') \
&& ((c) <= 'z') \
	) ||            \
	(   ((c) >= 'A') \
		&& ((c) <= 'Z') \
		)               \
	)
	
#define isprint(c) (c)
	
#define isupper(c) (   ((c) >= 'A') \
&& ((c) <= 'Z') \
	)
#define islower(c) (   ((c) >= 'a') \
&& ((c) <= 'z') \
	)
	
#define isdigit(c) (   ((c) >= '0') \
&& ((c) <= '9') \
	)
	
#define _tolower(c)	((int4)((c)-'A'+'a'))
#define _toupper(c)	((int4)((c)-'a'+'A'))
	
#ifdef __STRICT_BSD__
#define tolower(c)	_tolower(c)
#define toupper(c)	_toupper(c)
#define isascii(c)	((unsigned)(c)<=0177)
#define toascii(c)	((int4)((c)&0177))
#else
#ifndef __STRICT_ANSI__
#define tolower(c)	({int4 _c=(c); isupper(_c) ? _tolower(_c) : _c;})
#define toupper(c)	({int4 _c=(c); islower(_c) ? _toupper(_c) : _c;})
#define isascii(c)	((unsigned)(c)<=0177)
#define toascii(c)	((int4)((c)&0177))
#endif /* __STRICT_ANSI__ */
#endif /* __STRICT_BSD__ */
	
#else
#if defined(SYS_OS_MACH)  /* SYS_TRUESCAN */

#include "/usr/include/ansi/ctype.h"

#else /* not SYS_TRUESCAN */

#include <ctype.h>

#if defined(SYS_COMPILER_HIGHC)
#define isascii(c)	((unsigned)(c)<=0177)
#endif

#endif /* not SYS_TRUESCAN */
#endif
#endif

