/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

/*
// Compression types and functions
*/

#ifndef _comp_h_
#define _comp_h_

#define COMPMORE -5 /* refill data stream */
#define COMPEOF -4
#define MINCOMP 20 /* minimum space needed to encode */

struct EncodeState;
typedef struct EncodeState EncodeState;
typedef struct EncodeState *EncodeStatePtr;

struct DecodeState;
typedef struct DecodeState DecodeState;
typedef struct DecodeState *DecodeStatePtr;

EncodeStatePtr EncodeAlloc(void);
void EncodeInit(EncodeStatePtr,iImagePtr,iDAFSCompType);
void Encode(EncodeStatePtr, short *, short *);
void EncodeSetData(EncodeStatePtr,char*,int);
int EncodeGetAmt(EncodeStatePtr);
void EncodeFlush(EncodeStatePtr,iImagePtr im,int);
void EncodeFree(EncodeStatePtr);

DecodeStatePtr DecodeAlloc(void);
void DecodeInit(DecodeStatePtr,iImagePtr,iDAFSCompType);
void DecodeSetCodeRef(DecodeStatePtr,short*,short*);
void DecodeSetData(DecodeStatePtr,char *,int);
int Decode(DecodeStatePtr);
void DecodeFinish(DecodeStatePtr,iImagePtr);
void DecodeFree(DecodeStatePtr);

void i_InitComp(void);

#endif
