
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _ifc_h_
#define _ifc_h_

/*
// This module allows you to specify command line args in a
// structure and then it handles parsing and default values
// and environment variables for you
*/

#include "rafport.h"

enum IFCflags {
    IFC_INT,
    IFC_FLAG,
    IFC_STR,
    IFC_CHAR,
    IFC_SHORT,
    IFC_LONG,
    IFC_HEX,
    IFC_FLOAT,
    IFC_NA
};

struct ifc {
    char **val;
    long lval,init,fval,type;
    char *sw,*env;
};

typedef struct ifc ifc;

#ifdef __cplusplus
extern "C" {
#endif
	
int4 stripext(int4 c,char *v[],char *ev[]);
int4 processargs(int4 c, char *v[], ifc * ip);
	
#ifdef __cplusplus
};
#endif

#endif

