
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _KeyMap_h_
#define _KeyMap_h_

#include <X11/X.h>
#include <X11/Intrinsic.h>

#include "svpmap.h"
#include "aString.h"
#include "uString.h"
typedef unsigned short iUCode;
#define NORMAL   0
#define REVERSE  1

extern iUCode uNULL[]; // defined in KeyMap.cc

struct KeyValue {
	uString name;
	iUCode value;
	uString uvalue;
};

struct KeyRecord {
	KeySym sym;
	KeyValue normal;
	//KeyValue shifted;
	//KeyValue control;
};

class KeyMap {
	//static DLList *keyboard_list;
public:
	aString name;
	//aString file_name;
	
	// a map from keysym to display name
	
	stringVoidPtrMap map;
	stringVoidPtrMap control_map;
	
	KeyMap(aString);
	virtual ~KeyMap();
	
	void setTable(KeySym sym, uString name, iUCode value, uString uvalue);
	void setTable(KeySym sym, iUCode value);
	void setControlTable(KeySym sym, uString name, iUCode value, uString uvalue);
	void setControlTable(KeySym sym, iUCode value);

  void disableTable(KeySym sym);
  void disableControlTable(KeySym sym);
	
	iUCode lookupValue(KeySym keysym);
	uString lookupUValue(KeySym keysym);
	uString lookupName(KeySym keysym);
	iUCode lookupControlValue(KeySym keysym);
	uString lookupControlUValue(KeySym keysym);
	uString lookupControlName(KeySym keysym);	

	virtual uString context(const uString &line);
	virtual int spacing(iUCode character);
	virtual void getInfo(int *direction, iUCode *letter);
};


#endif
