
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _prompt_h_
#define _prompt_h_

#include <X11/Intrinsic.h>
#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif
	
/* 
// bogus -- these should be in the misc header files
*/

void uiInit(XtAppContext app_context, Widget app_shell);

int		uiAskUser2(const char *question, 
				   const char *ans1, 
				   const char *ans2, 
				   int default_ans);
	
int		uiAskUser3(const char *question, 
				   const char *ans1, 
				   const char *ans2, 
				   const char *ans3, 
				   int default_ans);
	
void	uiTellUser(const char *statement, 
				   const char *confirm);
	
void    uiTellUserN(const char **statements, 
					const char *confirm);
	
void    uiWarnUser(const char *statement, 
				   const char *confirm);
	
void    uiWarnUserUni(const iUCode *statement, 
					  const char *confirm);
	
#ifdef __cplusplus
};
#endif

#endif
