
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */
/*
// rafutil.h
//
//
// All those things that should have come with the C
// library
*/

#ifndef _rafutil_h_
#define _rafutil_h_

#include "rafport.h"
#include "str-lib.h"

/* defines everyone should know */
#define CAT(x,y) x ## y

#ifndef FALSE
#define FALSE 0
#define TRUE 1
#endif

#ifndef MAX
#define MAX(x, y) (( (x)>(y) ) ? (x) : (y) )
#define MIN(x, y) (( (x)<(y) ) ? (x) : (y) )
#endif

#ifndef DIFF
#define DIFF(x, y) (((x) < (y)) ? (y) - (x) : (x) - (y))
#endif

#ifndef ABS
#define ABS(x) (((x)<0) ? -(x) : (x)) 
#endif

#ifndef NULL
#define NULL ((void *)0)
#endif

#ifdef __cplusplus
extern "C" {
#endif

int4 fileSizeInBytes(const char *file_name);
	
void halt(char *s, ...);
void debugf(char *s, ...);

void HUGEPTR *memsetH(void HUGEPTR *, int, int4);

#if (defined SYS_OS_SUNOS)/* || (defined SYS_OS_MERC)*/
void *memmove(void *, const void *, int4);
void *memset(void *, int, int4);
#endif

#ifdef SYS_OS_MERC
#define debugf printf
#endif
#ifdef __cplusplus
};
#endif

#endif

