/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _H_rlimage_
#define _H_rlimage_
#include "rafport.h"


#define ST (sizeof(transition))
#define SL (sizeof(short))

#ifndef __cplusplus
typedef struct transition transition;
typedef struct RlLine RlLine;

typedef struct iChunk iChunk;
typedef struct iRaw iRaw;
typedef struct iImage iImage;
#endif

typedef struct RlLine *RlLinePtr;

typedef struct Rl iRl;
typedef struct Rl *iRlPtr;
typedef struct iChunk *iChunkPtr;
typedef struct iRaw *iRawPtr;
typedef struct iImage *iImagePtr;

struct transition {
    short up,dn;
};

struct RlLine {
    int2 size; /* size of this array */
    int2 asize; /* alloc'd size of this array */
    int2 last; /* last looked at transition */
    int2 unused;
    short *code; /* this points to the allocated run array */
    transition *run; /* this points to &code[1], therefore it shouldn't be freed */
};

struct Rl {
	RlLinePtr rl;
	long pixcnt,trncnt;
	iFixedPoint xmul,ymul;
	int rot;
	int2 x,y,w,h; /* smallest enclosing rectangle */
	struct iImage *next,*prev;
};


enum iType {
	Image,Raw
};

#ifndef __cplusplus
#ifdef SYS_OS_WIN16
typedef long iType;
#else
typedef enum iType iType;
#endif
#endif


struct iChunk {
	char *data;
	int len;
};

struct iRaw {
	iDAFSCompType comp;
	int invert,nchunks;
	iChunkPtr chunks;
};


struct iImage {
	iType type;
	int use;
	int4 id;
	int2 xOff,yOff,height,width,dpi;
	char *tag;
	union {
		iRl im;
		iRaw rw;
	} d;
};


Dll transition * APIENTRY rlseekx(RlLinePtr cl, int2 x);
Dll iImagePtr APIENTRY rotate(iImagePtr,short);

#endif
