
#ifndef _ConstrainedRectangle_h_
#define _ConstrainedRectangle_h_

#include "PackedRectangle.h"

class ConstrainedRectangle 
	:  public PackedRectangle {
protected:
	int can_move;
	int can_grow_up;
	int can_grow_down;
	int can_grow_left;
	int can_grow_right;
	Direction primary_growth_dir;
	Direction secondary_growth_dir;
	calculateGrowthDeltas(Rectangle *, Coord *, Coord *, Coord *, Coord *);
	checkIfCanGrow(Coord, Coord, Coord, Coord);
	
public:
	ConstrainedRectangle();
//	ConstrainedRectangle(Coord, Coord, Coord, Coord);
	ConstrainedRectangle(Direction, Direction, Coord);
	ConstrainedRectangle(int, int, int, int, int, Direction, Direction, Coord);
	ConstrainedRectangle(Coord, Coord, Coord, Coord, Direction, Direction, Coord);
	ConstrainedRectangle(Coord, Coord, Coord, Coord, int, int, int, int, int, 
						 Direction, Direction, Coord);
	int allocateArea(Coord, Coord, Coord, Coord, ChildRectangle *child);
	int allocateArea(ChildRectangle *rect, ChildRectangle *child);
	int isMovable() { return can_move; };
	Rectangle * areaUnion(Rectangle *rect);
	Direction primaryGrowDir() { return primary_growth_dir; };
	Direction secondaryGrowDir() { return secondary_growth_dir; };
	int canGrow(Direction);
	int growToContain(Rectangle *rect, int shift_children=TRUE);
	int canGrowToContain(Rectangle *);
	RectangleType getType() { return ConstrainedRectangleT; };
};

#endif
