#ifndef _RTE_
#define _RTE_
#include "Rectangle.h"
#include "PackedRectangle.h"
#include "RTEView.h"
#include "RTEMisc.h"
#include "RTECursor.h"

// forward declarations
class InputEventHandler;
class VirtualDisplayDevice;
class DAFSEntityWrapper;
class GlyphWrapper;


#if 0
class ImageElement : public ChildRectangle
{
	// members to be determined
public:
	ImageElement();
	ImageElement(Coord, Coord);
	ImageElement(Coord, Coord, Coord, Coord);
	virtual ~ImageElement();
	int erase() { return 0; };
	int draw() { return 0; };
	int drawRegion(Rectangle *rect) { return 0; };
};
#endif

class TextElement : public PackedRectangle
{
	// other private members to be determined
	DAFSEntityWrapper *DAFS_Entity;
public:
	TextElement nextTextElement();  // after me
	TextElement prevTextElement();  // before me
	void replaceWithTextElement(TextElement *te);  // replace me with
	void deleteTextElement();         // delete me
	void insertBefore(TextElement *te);   // insert before me
	void insertAfter(TextElement *te);    // insert after me
	RootElement * getRoot() { return this->parent->getRoot(); };
	void requestRedraw() { return; };
	void requestRedrawRegion(Rectangle *rect) { return; };
	int draw() { return 0; };
	int drawRegion() { return 0; };
	RectangleType getType() { return TextElementT; };
};


class CharacterElement : public ChildRectangle
{
	GlyphWrapper *glyph;
public:
	CharacterElement * nextCharElement();  // after me
	CharacterElement * prevCharElement();  // before me
	Direction getPrimaryWritingDir() { return ((PackedRectangle *)this->parent)->getPrimaryWritingDir(); }
	Direction getSecondaryWritingDir() { return ((PackedRectangle *)this->parent)->getSecondaryWritingDir(); }
	void insertBefore(CharacterElement *ce);   // insert before me
	void insertAfter(CharacterElement *ce);    // insert after me
	void deleteCharElement();              // delete me
	void replaceCharElement(CharacterElement *ce);  // replace me
	void requestRedraw() { return; };
	void requestRedrawRegion(Rectangle *rect) { return; };
	int draw() { return 0; };
	int drawRegion() { return 0; };
	RectangleType getType() { return CharacterElementT; };
};
#endif
