#ifndef _CURSOR_
#define _CURSOR_
#include "Rectangle.h"
#include "RTEView.h"
#include "RTEMisc.h"
#include "RTESet.h"

class RTECursor : public ChildRectangle
{
	Coord drag_x;
	Coord drag_y;
	CursorMode mode;
	RTESelectionManager *associated_selection_manager;
	static Coord default_height, default_width, default_offaxis;
	
	void setSize(Coord &width, Coord &height);
	ChildRectangle *getGoodChild(ElementSet *set);
	void elementsBoundedBy(Rectangle *area, ElementSet **set, ChildRectangle **first, ChildRectangle **last);
public:
	RTECursor(PackedRectangle *, RTESelectionManager *);  // initially at (0,0)
	RTECursor(PackedRectangle *, RTESelectionManager *, 
	          Coord, Coord, int);  // initially at specified location
	RTECursor(PackedRectangle *, RTESelectionManager *, 
	          Coord, Coord, Coord, Coord, int);  // specified location and size
	CursorMode getMode();
	void setInsertMode();
	static void setDefaults(Coord width, Coord height, Coord offaxis);
	void setReplaceMode();
	void cycleMode();
	void positionAt(Coord, Coord, int); // x, y, snap
	int becomeChildOf(ParentRectangle *parent); // virtual
	int becomeChildOf(ParentRectangle *parent, int redraw); // virtual
	int becomeChildOf(ParentRectangle *parent, int redraw, int allow_overlap); // virtual
	void getPosition(Coord *, Coord *);
	Coord getSize();
	void startDragSelect(Coord sx, Coord sy);
	void dragSelectTo(Coord, Coord);
	void endDragSelect();
	ChildRectangle * getNextElement();
	ChildRectangle * getPrevElement();
	int draw();
	int drawRegion(Rectangle *r) { return this->draw(); };
	int allowOverlap(void) { return TRUE; };
	RectangleType getType() { return CursorT; };
};

#endif
