#ifndef _RTEVIEW_
#define _RTEVIEW_

#include "rafutil.h"
#include <stdio.h>
#include <stdlib.h>

#define NDEBUG
#include "rafassert.h"


// Various type declarations used in rectangular text element routines.

typedef int ColorType;  // may want to change these 
typedef int LineStyle;

enum Direction {RTENone, LeftToRight, RightToLeft, TopToBottom, BottomToTop};
enum PlaneQuadrant {UpperLeft, UpperRight, LowerLeft, LowerRight};
enum CursorMode {Insert, Replace};
enum RectangleType { RectangleT, ChildRectangleT, ParentRectangleT,
                     ConstrainedRectangleT, PackedRectangleT, RootElementT,
                     CharacterElementT, TextElementT, CursorT,
		     UCRectangleT, UCStringT, UCParaT };

#define FIRST_CURSOR_MODE Insert
#define LAST_CURSOR_MODE Replace
#define DEFAULT_CURSOR_WIDTH 1
#define DEFAULT_CURSOR_HEIGHT 10

// value to indicate a logical variable which is not set (neither TRUE nor FALSE)
#define UNSPEC (TRUE+1)

typedef short queue_priority; 

typedef short Coord;    // type of number used to represent screen coordinates
#define MAXCoord 0x7FFF // Max absolute value for Coord
#define VALIDCoord(x) 	(((x) >= 0) && ((x) <= MAXCoord))  // Check whether int x is safe to convert

#endif
