#ifndef _UCRECTANGLE_
#define _UCRECTANGLE_
#include "RTEView.h"
#include "RTEMisc.h"
#include "Rectangle.h"
#include "ConstrainedRectangle.h"
#include "dafstype.h"
#include "uString.h"
#include "keyboard/KeyMap.h"

class UCRectangle : public ChildRectangle
{
	uString glyph, context;	
	Coord a;

	void measure(VirtualDisplayDevice *vdd);

public:
	UCRectangle(uString &text);
	virtual ~UCRectangle(void);
	uString getUString(void);
	void addMark(iUCode mark);
	int setContext(uString &text);

	int draw();
	int drawRegion(Rectangle *r);
	int erase();

	RectangleType getType(void) { return (RectangleType) UCRectangleT; };
};

class UCString : public ConstrainedRectangle
{
        int do_context;
	static int line_spacing;

	uString assemble(int start, int stop);
	uString assemble(void);
	void context(int start, int stop, int index);
	void context(void);

public:
	UCString(KeyMap *km, Coord width);
	UCString(Direction direction);
	~UCString(void) { };
	void keyPress(iUCode key_stroke);
	static void setSpacing(int spacing) { line_spacing = spacing; };
	int maximizeWidth(void) { return FALSE; };
	void changeDirection(Direction direction);
	void enableContext(void) { do_context = TRUE; context(); };
	void disableContext(void) { do_context = FALSE; };
	void performContext(UCRectangle *glyph);

	uString getString(void);
	RectangleType getType(void) { return (RectangleType) UCStringT; };
};

class UCPara : public ConstrainedRectangle
{
  static int line_spacing;

public:
  UCPara(Coord width);
  ~UCPara(void) { };
  int maximizeWidth(void) { return TRUE; };
  static void setSpacing(int spacing) { line_spacing = spacing; };
  void keyPress(iUCode key_stroke);
  uString getString(void);
  void changeDirection(Direction direction);
  int numGlyphs(void);
  RectangleType getType(void) { return (RectangleType) UCParaT; };
};
#endif



