#ifndef _VDD_h_
#define _VDD_h_

#include <Xm/Xm.h>
#include "ucs.h"
#include "uString.h"
#include "misc/Unicode.h"

class InputEventHandler {
};

class VirtualDisplayDevice {
private:
  int enable;

  Widget widget;
  GC gc;
  Drawable drawable;
  Pixmap buffer;
  int buffer_x, buffer_y, buffer_w, buffer_h;  

public:
  VirtualDisplayDevice(Widget w, GC g);
  void setDrawable(void) { if(enable > 0) drawable = XtWindow(widget); };
  int  buffered(void) { return (buffer != 0); };
  int  enabled(void) { return enable; };

  void measureGlyph(iUCode glyph, int *w, int *h, int *a);
  void drawGlyph(iUCode glyph, int x, int y, int a);
  void fillRect(int x, int y, int w, int h);
  void drawRect(int x, int y, int w, int h);
  void eraseRect(int x, int y, int w, int h);
  void inverse(void);
  void enableGraphics(void) { enable++; if(!drawable) setDrawable(); };
  void disableGraphics(void) { enable--; };

  void makeBuffer(int x, int y, int w, int h);
  void drawBuffer(void);
  void freeBuffer(void);

  void changeSizeTo(Dimension w, Dimension h);
};

#endif
