/*
 * Copyright (c) 1994, 1995 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */
/*
 * $Id: ucs.h,v 1.24 1995/09/22 16:21:32 mike Exp $
 */

/*
 * Copyright 1990, 1991 by OMRON Corporation, NTT Software Corporation,
 *                      and Nippon Telegraph and Telephone Corporation
 * Copyright 1991 by the Massachusetts Institute of Technology
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of OMRON, NTT Software, NTT, and M.I.T.
 * not be used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission. OMRON, NTT Software,
 * NTT, and M.I.T. make no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without express or
 * implied warranty.
 *
 * OMRON, NTT SOFTWARE, NTT, AND M.I.T. DISCLAIM ALL WARRANTIES WITH REGARD
 * TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT SHALL OMRON, NTT SOFTWARE, NTT, OR M.I.T. BE
 * LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 *	Author: Li Yuhong	OMRON Corporation
 * */

#ifndef	_ucs_h_ 
#define _ucs_h_

#include "rafport.h"
#include "dafstype.h"

#ifdef __cplusplus
extern "C" {
#endif 
	
#ifndef UNULL
	
#define UNULL	0
#define UEOF	0xffff

#endif
	
#define UTF_LEN_MAX 6
	
/***********************/
/* Copy from "mit/lib/X/Xsi/iUCodeint.h" */
#ifndef	SCRIPT1

#define SCRIPT1		0xff00
#define CONTROLSCRIPT	0x00ff
#define LATINSCRIPT     0x0000

#define HIRAGANASCRIPT	0x3040
#define KATAKANASCRIPT	0x30A0
#define HANZISCRIPT	0x4000
#define KANJISCRIPT	0x4000
#define HANJASCRIPT	0x4000

#endif

	
#define CLPADPADPAD	0x0000
	
#define	wgetgroup(uc)	((unsigned char)(((uc) >> 8) & 0x00ff))
#define	wgetcell(uc)	((unsigned char)((uc) & 0x00ff))


/***********************/
/*
 * macro version of iUCode functions
 *	Macros here evaluate their argument more than once
 *	Please take care to use these macros.
 *
 * COMMENT:  DEL is 0x7f
 *
 *	List of macros:	_isualnum(), _isualpha(), _isudigit(),
 *			_isulower(), _isupunct(), _isuupper(),
 *			_isuxdigit(),
 *			_isucntrl(), _isuspace(),
 *			_towupper(), _towupper(),
 *			_atouc(), _uctoa()
 *			_isulatin1()
 *	Function only:	isuascii(), isublank(), isugraph(), isuprint()
 */

#if 1
	/* !defined(SYS_OS_DOS) && !defined(SYS_PR)*/ 
/*macros*/
#define	_isualnum(uc)	( ((uc)&SCRIPT1)==LATINSCRIPT	\
&& isascii(wgetcell(uc)) && isalnum(wgetcell(uc)) )
#define	_isualpha(uc)	( ((uc)&SCRIPT1)==LATINSCRIPT	\
&& isascii(wgetcell(uc)) && isalpha(wgetcell(uc)) )
#define	_isudigit(uc)	( ((uc)&SCRIPT1)==LATINSCRIPT	\
&& isascii(wgetcell(uc)) && isdigit(wgetcell(uc)) )
#define	_isulower(uc)	( ((uc)&SCRIPT1)==LATINSCRIPT	\
&& isascii(wgetcell(uc)) && islower(wgetcell(uc)) )
#define	_isupunct(uc)	( ((uc)&SCRIPT1)==LATINSCRIPT	\
&& isascii(wgetcell(uc)) && ispunct(wgetcell(uc)) )
#define	_isuupper(uc)	( ((uc)&SCRIPT1)==LATINSCRIPT	\
&& isascii(wgetcell(uc)) && isupper(wgetcell(uc)) )
#define	_isuxdigit(uc)	( ((uc)&SCRIPT1)==LATINSCRIPT	\
&& isascii(wgetcell(uc)) && isxdigit(wgetcell(uc)) )
#define	_isulatin1(uc)	( ((uc)&SCRIPT1)==LATINSCRIPT || _isucntrl(uc) )
	

/* bogus */	
#if 0
  #define	_isucntrl(uc)	( ((uc)==UNULL) || (((uc)&CONTROLSCRIPT)==CLPADPADPAD \
  && iscntrl(wgetgroup(uc)&0x7f)) )
  #define	_isuspace(uc)	( (((uc)&CONTROLSCRIPT)==CLPADPADPAD) ?	\
  (isspace(wgetgroup(uc))) :		\
  (_isublank(uc)) )
  #define	_isuprint(uc)	isuprint(uc)
#else
  #define _isucntrl(uc)  (0)
  #define _isuspace(uc) (0)
#endif

#define	_isuascii(uc)	isuascii(uc)
#define	_isublank(uc)	isublank(uc)
#define	_isugraph(uc)	isugraph(uc)
	
#define	_towlower(uc)	( (_isuupper(uc))?			\
	(LATINSCRIPT|(tolower(wgetcell(uc)))):	\
	(uc) )
#define	_towupper(uc)	( (_isulower(uc))?			\
	(LATINSCRIPT|(toupper(wgetcell(uc)))):	\
	(uc) )

#endif /*macros*/
	
#if 0

#define	_atouc(c)	( ((c)=='\0') ? UNULL:				\
	(iscntrl((c)&0x7f)) ? (((c)<<24)|CLPADPADPAD):	\
	(LATINSCRIPT|(c)) )
#define	_uctoa(uc)	( _isucntrl(uc) ? wgetgroup(uc):		\
	(((uc)&SCRIPT1)==LATINSCRIPT) ? wgetcell(uc):	\
	(-1) )

#else

#define	_atouc(c)	( ((c)=='\0') ? UNULL:				\
	(LATINSCRIPT|(c)))
#define	_uctoa(uc)	 ( (((uc)&SCRIPT1)==LATINSCRIPT) ? wgetcell(uc):	\
	(-1) )

#endif
	
/*
 * Function declarations
#if !defined(SYS_COMPILER_WATCOM) && !defined(SYS_OS_AIX) jt was here
 */
#if !defined(SYS_OS_AIX)
	Dll  int4 APIENTRY isualnum(iUCode);
	Dll  int4 APIENTRY isualpha(iUCode);
	Dll  int4 APIENTRY isuascii(iUCode);	/* not in MSE */
	Dll  int4 APIENTRY isublank(iUCode);	/* not in MSE */
	Dll  int4 APIENTRY isucntrl(iUCode);
	Dll  int4 APIENTRY isudigit(iUCode);
	Dll  int4 APIENTRY isulatin1(iUCode);	/* not in MSE */
	Dll  int4 APIENTRY isulower(iUCode);
	Dll  int4 APIENTRY isuspace(iUCode);
	Dll  int4 APIENTRY isuupper(iUCode);
	Dll  int4 APIENTRY isuxdigit(iUCode);
	Dll  iUCode APIENTRY toulower(iUCode);
	Dll  iUCode APIENTRY touupper(iUCode);
#endif
	
/* 
 * functions similar to char string manupulation.
 */

	Dll  iUCode * APIENTRY ucscpy(iUCode*, const iUCode*);
	Dll  iUCode * APIENTRY ucsncpy(iUCode*, const iUCode*, int2);
	Dll  iUCode * APIENTRY ucscat(iUCode*, const iUCode*);
	Dll  iUCode * APIENTRY ucsncat(iUCode*, const iUCode*, int2);
#if 0
which malloc does this call and what free do I use
	Dll  iUCode * APIENTRY ucsdup(iUCode *);
#endif
	Dll  int APIENTRY	ucscmp(const iUCode*, const iUCode*);
	Dll  int APIENTRY	ucsncmp(const iUCode*, const iUCode*, int2);
	Dll  const iUCode * APIENTRY ucschr(const iUCode*, iUCode);
	Dll  const iUCode * APIENTRY ucsrchr(const iUCode*, iUCode);
	Dll  unsigned APIENTRY	ucslen(const iUCode*);
	Dll  void APIENTRY	ucsreverse(iUCode*);		/* not in MSE */

	Dll  unsigned long APIENTRY ucsspn(iUCode *, iUCode *);
	Dll  unsigned long APIENTRY ucscspn(iUCode *, iUCode *);
	
	Dll  iUCode * APIENTRY ucspbrk(iUCode *, iUCode *);
	Dll  iUCode * APIENTRY ucsucs(iUCode *, iUCode *);

    Dll int4 APIENTRY isupunct(iUCode uc);
    Dll long APIENTRY ucstol(iUCode *ucs, iUCode **ptr, int4 base);

#ifdef __cplusplus
	};
#endif
	
	
#endif



