#############################################################
#
# This makefile copyright 1993 RAF Technology
# All rights reserved
#
# Author: Thomas M. J. Fruchterman
#
#############################################################
#
# included at the top of makefiles
#
# makes definitions of rules and variables
#

#
# if DEVEL is defined we know we are in normal RAF space
# and can count on many variables being defined
#
# if not we know we are code loaned to somebody
# else and makefiles must be simpler and more explicit
#
ifdef DEVEL
# these should be defined in the .cshrc file
#LOCAL_DIR=${HOME}/src/ill
#MASTER_DIR =/raf/this/home/devel/src/ill
#OBJ_DIR = obj
#BIN_DIR = ${ARCH_TARGET}
else
MASTER_DIR = /
LOCAL_DIR=$(shell pwd)/..
OBJ_DIR=obj
BIN_DIR=.
AR=ar rcv
RANLIB=ranlib
endif

LIB_NAME=bogus1
APP_NAME=bogus2
MOD_NAME=bogus3
TEST_TARGET=bogus5
LIB_TARGET=bogus6
APP_TARGET=bogus7
MOD_TARGET=bogus8
APP_STATIC = bogus9

LOCAL_LIB_DIR=${LOCAL_DIR}/lib
MASTER_LIB_DIR=${MASTER_DIR}/lib

LOCAL_INCLUDE_DIR=${LOCAL_DIR}/include
MASTER_INCLUDE_DIR=${MASTER_DIR}/include
LOCAL_BIN_DIR =${LOCAL_DIR}/bin/${BIN_DIR}

ifdef DEVEL
INCLUDE_PATH=-I. -I${LOCAL_INCLUDE_DIR} -I${MASTER_INCLUDE_DIR}
else
INCLUDE_PATH=-I. -I${LOCAL_INCLUDE_DIR}  
endif

LIB_PATH= \
	-L${LOCAL_LIB_DIR}/${OBJ_DIR} \
	-L${MASTER_LIB_DIR}/${OBJ_DIR}

GLOBAL_DEFINES=
CFLAGS+=${INCLUDE_PATH} ${GLOBAL_DEFINES}${ARCH_FLAGS} 

${OBJ_DIR}/%.o:%.c
	@-test -d ${OBJ_DIR} || mkdir ${OBJ_DIR}
	${CC} -c ${CFLAGS} $*.c -o $@

# bogus -- get rid of g++-include?
${OBJ_DIR}/%.o:%.cc
	-test -d ${OBJ_DIR} || mkdir ${OBJ_DIR}
	${CXX} -c -I/usr/local/lib/g++-include ${CFLAGS} $*.cc -o $@

%.i:%.c
	${CC} -E ${CFLAGS} $*.c -o $@

%.i:%.cc
	${CXX} -E -I/usr/local/lib/g++-include ${CFLAGS} $*.cc -o $@

${OBJ_DIR}/%:${OBJ_DIR}/%.o
	${CC} ${CFLAGS} ${LOAD_FLAGS} ${LIB_PATH} ${OBJ_DIR}/$*.o -o $@ ${LIBS}


$(OBJ_DIR)/%.d: %.c
	@-test -d ${OBJ_DIR} || mkdir ${OBJ_DIR}
	$(CC) -MM $(CFLAGS) $< | sed 's;$*.o;${OBJ_DIR}/& $@;g' > $@

$(OBJ_DIR)/%.d: %.cc
	@-test -d ${OBJ_DIR} || mkdir ${OBJ_DIR}
	$(CPP) -MM $(CFLAGS) $< | sed 's;$*.o;${OBJ_DIR}/& $@;g' > $@



${LOCAL_LIB_DIR}/${OBJ_DIR}/%.o:  ${LOCAL_LIB_DIR} ${LOCAL_LIB_DIR}/${OBJ_DIR} ${OBJ_DIR}/%.o
	cp ${OBJ_DIR}/$*.o $@
	${RANLIB} -t $@

${LOCAL_INCLUDE_DIR}${SUBDIR}/%.h: ${LOCAL_INCLUDE_DIR}${SUBDIR} %.h
	chmod +w $@
	cp $*.h $@
	chmod +w $@

${LOCAL_LIB_DIR}/${OBJ_DIR}/%.a:  ${LOCAL_LIB_DIR} ${LOCAL_LIB_DIR}/${OBJ_DIR} ${OBJ_DIR}/%.a
	cp ${OBJ_DIR}/$*.a $@
	${RANLIB} -t $@
