#include "VDD.h"


VirtualDisplayDevice::VirtualDisplayDevice(Widget w, GC g)
{
  widget = w;
  gc = g;
  drawable = buffer = 0;
  enable = 0;
}

void 
VirtualDisplayDevice::makeBuffer(int x, int y, int w, int h) 
{
  return;

  buffer = XCreatePixmap(XtDisplay(widget), RootWindowOfScreen(XtScreen(widget)), 
			 w, h, DefaultDepthOfScreen(XtScreen(widget)));

  XGCValues gcv;
  XGetGCValues(XtDisplay(widget), gc, GCForeground | GCBackground, &gcv);  
  XSetForeground(XtDisplay(widget), gc, gcv.background);
  XFillRectangle(XtDisplay(widget), buffer, gc, 0, 0, w, h);
  XSetForeground(XtDisplay(widget), gc, gcv.foreground);

  buffer_x = x;
  buffer_y = y;
  buffer_w = w;
  buffer_h = h;

  drawable = buffer;
}

void
VirtualDisplayDevice::drawBuffer(void)
{
  return;

  XCopyArea(XtDisplay(widget), buffer, XtWindow(widget), gc, 0, 0, 
	    buffer_w, buffer_h, buffer_x, buffer_y);
}

void
VirtualDisplayDevice::freeBuffer(void) 
{
  return;

  XFreePixmap(XtDisplay(widget), buffer);
  buffer = 0;

  drawable = XtWindow(widget);
}

void
VirtualDisplayDevice::measureGlyph(iUCode glyph, int *w, int *h, int *a)
{
  measureUnicode(XtDisplay(widget), &glyph, 1, w, h, a);
}

void
VirtualDisplayDevice::drawGlyph(iUCode glyph, int x, int y, int a)
{
  if(a == 1000) {
    int w, h;
    measureGlyph(glyph, &w, &h, &a);
  }
    
  if(enable > 0)
    drawUnicodeChar(XtDisplay(widget), drawable, gc, x, y+a, glyph);
}

void
VirtualDisplayDevice::fillRect(int x, int y, int w, int h)
{
  if(enable > 0)
    XFillRectangle(XtDisplay(widget), drawable, gc, x, y, w, h);
}

void
VirtualDisplayDevice::drawRect(int x, int y, int w, int h)
{
  if(enable > 0) {
    if(w > 1 && h > 1)
      XDrawRectangle(XtDisplay(widget), drawable, gc, x, y, w-1, h-1);
    else
      XDrawRectangle(XtDisplay(widget), drawable, gc, x, y, w , h);
  }
}

void
VirtualDisplayDevice::eraseRect(int x, int y, int w, int h)
{
  XGCValues gcv;
  XGetGCValues(XtDisplay(widget), gc, GCForeground | GCBackground, &gcv);
  XSetForeground(XtDisplay(widget), gc, gcv.background);
  fillRect(x, y, w, h);
  XSetForeground(XtDisplay(widget), gc, gcv.foreground);
}

void
VirtualDisplayDevice::inverse(void)
{
  XGCValues gcv;
  XGetGCValues(XtDisplay(widget), gc, GCForeground | GCBackground, &gcv);
  XSetForeground(XtDisplay(widget), gc, gcv.background);
  XSetBackground(XtDisplay(widget), gc, gcv.foreground);
}

void
VirtualDisplayDevice::changeSizeTo(Dimension w, Dimension h)
{
  XtVaSetValues(this->widget,
		XmNheight, h,
		XmNwidth, w,
		NULL);
  this->freeBuffer();
  this->makeBuffer(0,0,w,h);
}
