
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

/*
// a C++ interface to dllist
// it really contains nothing at all original
// it is not used by anybody right now, but was an offshoot
// of the way I improved the text view
// not to use its own lists
*/

#include "List.h"

List::List()
{
	dllistCtor(&this->children);
}

List::~List()
{
	dllistDtor(&this->children);
}

void 
List::insert(VoidPtr input_child)
{
	dllistAppend(&this->children, input_child);
}

void 
List::insertAfter(VoidPtr new_element, 
				  VoidPtr old_element)
{
	DLList *l = &this->children;
	Ref r;
	
	r = dllistSeek(l, old_element);
	
	dllistInsertAfter(l, r, new_element);
}

Ref 
List::first()
{
	return dllistFirst(&this->children);
}

VoidPtr 
List::contents(Ref r)
{
	return (VoidPtr ) dllistContents(&this->children, r);
}

void 
List::next(Ref* r_ptr)
{
	dllistNext(&this->children, r_ptr);
}

void 
List::prev(Ref* r_ptr)
{
	dllistPrev(&this->children, r_ptr);
}

Ref 
List::last()
{
	return dllistLast(&this->children);
}

Ref 
List::seek(VoidPtr sought)
{
	return dllistSeek(&this->children, sought);
}

int
List::length()
{
	return dllistLength(&this->children);
}

void
List::remove(Ref r)
{
	dllistRemove(&this->children, r);
}


