
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#include "util/port.h"

#include "util/util.h"
#include "util/defines.h"

#include "ds/hash.h"
#include "ds/map.h"


void 
mapCtor(Map *that, VoidPtr default_value)
{
}

void 
mapDtor(Map *that)
{
}

int 
mapEmpty(Map *that)
{
	return that->num_elements == 0;
}

int 
mapLength(Map *that)
{
	return that->num_elements;
}

static MapElement *
findElementFromKey(Map *that, char *k)
{
}

VoidPtr *
mapIndex(Map *that, char *key)
{
	MapElement *element;
	
	element = findElementFromKey(that, key);
	if(element->active == 0){
		element->active = 1;
		strcpy(element->key, key);
		that->num_elements++;
	} else if (element->deleted) {
		element->active = 1;
		that->num_elements++;
		element->element = that->default_value;
	}
	
	return &(element->element);
}

int 
mapContains(Map *that, char *k)
{
	MapElement *element = findElementFromKey(that, k);
	
	return element->active && (element->deleted == FALSE);
}

void 
mapDelete(Map *that, char *key)
{
	MapElement *element = findElementFromKey(that, key);
	
	if(mapContains(that, key) == FALSE)
		halt("Attempted to delete non-existent element.\n");
	
	element->deleted = TRUE;
}

void 
mapClear(Map *that)
{
	MapElement *element;
	int i;
	
	for(i = 0; i < that->max_elements; i++){
		element = that->element_array + i;
		element->element = that->default_value;
		strcpy(element->key, "");
		element->active = element->deleted = FALSE;
	}
	that->num_elements = 0;
}

VoidPtr 
mapDefaultValue(Map *that)
{
	return that->default_value;
}

char * 
mapKey(Map *that, Ref ref, char buffer[])
{
	MapElement *element = (MapElement *) ref;
	
	strcpy(buffer, element->key);
	
	return buffer;
}


/* generic container */
VoidPtr 
mapContents(Map *that, Ref ref)
{
	MapElement *element = (MapElement *) ref;
	
	return element->element;
}

Ref 
mapFirst(Map *that)
{
	
}

void 
mapNext(Map *that, Ref *ref)
{
	
}

Ref 
mapSeek(Map *that, char *k)
{
	
}

