
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef MAP_H
#define MAP_H

/*
// define a string VoidPtr map
// Map *that
// string k
// VoidPtr item
// Ref ref
*/

#define MAX_KEY_LENGTH 256

typedef char Key[256];

struct MapElement {
	int active;
	int deleted;
	Key key;
	VoidPtr element;
};

typedef struct MapElement MapElement;

struct Map {
	MapElement *element_array;
	int max_elements;
	int num_elements;
	VoidPtr default_value;
};

typedef struct Map Map;

void mapCtor(Map *that, VoidPtr default_value);
void mapDtor(Map *that);
int mapEmpty(Map *that);
int mapLength(Map *that);
VoidPtr *mapIndex(Map *that, char *k);
int mapContains(Map *that, char *k);
void mapDelete(Map *that, char *k);
void mapClear(Map *that);
VoidPtr mapDefaultValue(Map *that);
char * mapKey(Map *that, Ref ref, char buffer[]);

/* generic container */
VoidPtr mapContents(Map *that, Ref ref);
Ref mapFirst(Map *that);
void mapNext(Map *that, Ref *ref);
Ref mapSeek(Map *that, char *k);


#endif
