
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */


/*
// This file is for debugging use only -- when we override malloc
// so that we can track memory use in X, etc.
*/

#ifndef _memdbg_h_
#define _memdbg_h_

	#if defined(WIN32) /* || defined(SYS_OS_LINUX) */
		#define USE_RAF_MALLOC
	#elif 0 /* || defined(MAVERICK) */
		#define USE_GNU_MALLOC
	#else
		#define USE_MALLOC
	#endif
	
	#ifdef USE_MALLOC
		#define INTERNAL_MALLOC malloc
		#define INTERNAL_REALLOC realloc
		#define INTERNAL_FREE free
	#endif
	#ifdef USE_RAF_MALLOC
		extern void * raf_malloc  (unsigned long __size);
		extern void * raf_realloc  (void * __ptr, unsigned long __size);
		extern void raf_free  (void * __ptr);
		#define INTERNAL_MALLOC raf_malloc
		#define INTERNAL_REALLOC raf_realloc
		#define INTERNAL_FREE raf_free
	#endif

#endif
