
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#include "util/port.h"

#include "util/defines.h"
#include "util/util.h"

#include "set.h"

void 
setCtor(Set *that)
{
	setClear(that);
}

void 
setDtor(Set *that)
{
	that = that;
}

int 
setEmpty(Set *that)
{
	return that->count == 0;
}

int setLength(Set *that)
{
	return that->count;
}

Ref setAdd(Set *that, VoidPtr item)
{
	int c = (int) item;
	
	if(setContains(that, item) == FALSE){
		that->array[c] = c;
		that->count++;
	}
	
	return (Ref) c;
}

void 
setDelete(Set *that, VoidPtr item)
{
	int c = (int) item;
	
	if(setContains(that, item) == FALSE)
		halt("setDelete::attempted to remove non-existent member.\n");
	that->array[c] = 0;
	that->count--;
}

void setClear(Set *that)
{
	int i;
	
	for(i = 0; i < SET_ARRAY_SIZE; i++)
		that->array[i] = 0;
	that->count = 0;
}

int 
setContains(Set *that, VoidPtr item)
{
	int c = (int) item;
	
	return that->array[c] == c;
}
