
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef SET_H
#define SET_H

#include "util/port.h"

#define SET_ARRAY_SIZE 256

struct Set {
	byte array[SET_ARRAY_SIZE];
	int count;
};

typedef struct Set Set;

void setCtor(Set *);
void setDtor(Set *);

int setEmpty(Set *);
int setLength(Set *);
Ref setAdd(Set *, VoidPtr);
void setDelete(Set *, VoidPtr);
void setClear(Set *);
int setContains(Set *, VoidPtr);
VoidPtr setContents(Set *, Ref);
Ref setFirst(Set *);
void setNext(Set *, Ref *);
Ref setSeek(Set *, VoidPtr);
int setEqual(Set *, Set *);
int setNotEqual(Set *, Set *);
int setSubset(Set *, Set *);
void setAddSet(Set *, Set *);
void setSubtractSet(Set *, Set *);
void setSubtractIntersectionComplement(Set *, Set *);

#endif
