
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */


#include "uString.h"
#include "aString.h"

#include "illtk.h"

#if 0
Tcl_CreateCommand(interp, "utf", UtfCmd, (ClientData) 0,
				  (void (*)()) NULL);
Tcl_CreateCommand(interp, "ucs", UcsCmd, (ClientData) 0,
				  (void (*)()) NULL);
#endif

aString
ucs2utf(const aString& ucs)
{
	int num_scanned;
	int result;
	aString as;
	uString us;
	uChar   uc[2];
	
	num_scanned = sscanf(ucs.string(), "U+%x", &result);
	
	if((num_scanned != 1) || result < 0 || result > 0xffff)
		return 0;
	
	uc[0] = result;
	uc[1] = UNULL;
	
	us = uc;
	us.putUtf(as);
	
	return as;
}

/* ARGSUSED */
extern "C" int
UtfCmd(
	ClientData dummy,			/* Not used. */
	Tcl_Interp *interp,			/* Current interpreter. */
	int argc,				/* Number of arguments. */
	char **argv)			/* Argument strings. */
{
	aString result;
#if 0
	printf("boo");
#endif
	if ((argc != 2) || ((result = ucs2utf(argv[1])) == 0)) {
		Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0],
						 " U+nnnn\"", (char *) NULL);
		return TCL_ERROR;
	}
	
	Tcl_AppendResult(interp, result.string(), (char *) NULL);
	
	return TCL_OK;
}


extern "C" int
Tk_KEntryCmd(
    ClientData clientData,
    Tcl_Interp *interp,
    int argc,	
    char **argv);

