#ifndef PLAN9
#include	<sys/types.h>
#include	<stdio.h>
#include	<unistd.h>
#include	<stdlib.h>
#include	<fcntl.h>
#include	<string.h>
#include	<errno.h>
#include	"plan9.h"
#else /* PLAN9 */
#include	<u.h>
#include	<libc.h>
#include	<bio.h>
#endif /* PLAN9 */

#include	"hdr.h"
#include	"conv.h"
#include    "dafs.h"

#include    "tcs_raf.h"

void usage(void);

int
main(int argc, char **argv)
{
#if 1
	char test_input[] = "ܸ";
/*
  what I expect for output
  0000000  feff 65e5 672c 8a9e 000a
              x    x    x    x
      	         ni   hon  go
				 
*/

	iUCode test_output[64];
	int i, n;
	/* order char */
	short pre = 0xfeff;
	/* unicode return */
	short post = 0x000a;

	jis2unicode(test_input, test_output);
	n = ucslen(test_output);
	
	write(1, &pre, 2);
	write(1, test_output, n * sizeof(iUCode));
	write(1, &post, 2);
#else
	char *from = "utf";
	char *to = "utf";
	int fd;
	int listem = 0;
	struct convert *t, *f;

	ARGBEGIN{
	case 'c':	clean = 1; break;
	case 'f':	from = ARGF(); break;	
	case 'l':	listem = 1; break;
	case 's':	squawk = 0; break;
	case 't':	to = ARGF(); break;
	case 'v':	verbose = 1; break;
	default:	usage(); break;
	}ARGEND
	USED(argc);
	if(verbose)
		squawk = 1;
	if(listem){
		list();
		EXIT(0, 0);
	}
	if(!from || !to)
		usage();
	f = conv(from, 1);
	t = conv(to, 0);
#define	PROC	{if(f->flags&TCSTable)\
			intable(fd, (long *)f->data, t);\
		else\
			((Infn)(f->fn))(fd, (long *)0, t);}

	if(*argv){
		while(*argv){
			file = *argv;
#ifndef PLAN9
			if((fd = open(*argv, 0)) < 0){
				EPR "%s: %s: %s\n", argv0, *argv, strerror(errno));
#else /* PLAN9 */
			if((fd = open(*argv, OREAD)) < 0){
				EPR "%s: %s: %r\n", argv0, *argv);
#endif /* PLAN9 */
				EXIT(1, "open failure");
			}
			PROC
			close(fd);
			argv++;
		}
	} else {
		fd = 0;
		PROC
	}
	if(verbose)
		EPR "%s: %ld input bytes, %ld runes, %ld output bytes (%ld errors)\n", argv0,
			ninput, nrunes, noutput, nerrors);
	EXIT(((nerrors && squawk)? 1:0), ((nerrors && squawk)? "conversion error":0));
#endif
	return(0);	/* shut up compiler */

}

void
usage(void)
{
	EPR "Usage: %s [-slv] [-f cs] [-t cs] [file ...]\n", argv0);
	list();
	EXIT(1, "usage");
}
